define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var touch = require("./js/touch");
	var common = require("./common");

	var Model = function(){
		this.callParent();
	};
	
	Model.prototype.modelLoad = function(event){
	if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
			$(".nav").css({"top":"78px"});
			$(".ios-tab-content .tab-pane").css({"top":"50px"});
		}
		this.swipeDelete();
		$(".loadingDiv").addClass("hide");
		$(".tab-content").removeClass("hide");
	};
		
	Model.prototype.swipeDelete = function(){
		var newsContentID = this.getIDByXID('tab-content');
		var swipeAreaSize = 100;
		var dx;
		touch.on('#' + newsContentID, 'touchstart', function(ev){
//			ev.preventDefault();	
			var $li = $('#' + newsContentID + " li");
					dx = parseInt($li.has(ev.target).attr('swipeX') || "0");
			$li.each(function(){
				$(this).bind('touchstart',function(e){
					$(this).has(e.target).siblings('li').css({'transform':'translate3d(0, 0, 0)','-webkit-transform':'translate3d(0, 0, 0)','transition': 'transform 0.2s linear 0s','-webkit-transition': 'transform 0.2s linear 0s'});
				});
				
			});

		});
	
		touch.on('#'+ newsContentID, 'drag', function(ev){
			var $swipNode = $('#' + newsContentID + " li").has(ev.target);
			if(ev.direction === "left" || ev.direction === "right"){
				dx = dx || 0;
				var offx = dx + ev.x;
				if(offx < swipeAreaSize*-1){
				offx = swipeAreaSize*-1;
					
				}
				if(offx > 0){
					
					offx = 0;
				}
				if(ev.direction === "right" && $swipNode.hasClass('x-swipe-out')){
					$swipNode.css({'transform':'translate3d('+offx+'px,0,0)','-webkit-transform':'translate3d('+offx+'px,0,0)'});
				}else if(ev.direction === "left" && (!$swipNode.hasClass('x-swipe-out'))){
					$swipNode.css({'transform':'translate3d('+offx+'px,0,0)','-webkit-transform':'translate3d('+offx+'px,0,0)'});
				}
			}
		});
		touch.on('#'+ newsContentID, 'dragend', function(ev){
			var $swipNode = $('#' + newsContentID + " li").has(ev.target);
			if(ev.direction === "left"){
				if($swipNode.children('.x-swipe-area').children().length>1){
				var offx=swipeAreaSize*2;
					$swipNode.css({'transform':'translate3d(-'+offx+'px,0,0)','-webkit-transform':'translate3d(-'+offx+'px,0,0)'});
					}else{
					$swipNode.css({'transform':'translate3d(-'+swipeAreaSize+'px,0,0)','-webkit-transform':'translate3d(-'+swipeAreaSize+'px,0,0)'});
					}
				
				$swipNode.addClass('x-swipe-out');
				dx = swipeAreaSize*-1;
			}else if(ev.direction === "right"){
				$swipNode.removeClass('x-swipe-out');
				$swipNode.css({'transform':'translate3d(0,0,0)','-webkit-transform':'translate3d(0,0,0)'});
				dx = 0;
			}
			$swipNode.attr('swipeX',dx);
		});
	};
	
	// 朗诵和朗诵上传时间操作
	Model.prototype.setUploadPosition = function(time) {
		return common.fbTimeToFormat(time);
	};
	
	// 获取当前用户的朗诵草稿
	Model.prototype.reciteDataBeforeRefresh = function(event){
		event.source.setFilter("filter", "reciteUserId="+this.getContext().getRequestParameter("userId")+" and state=3 and status=1");
	};
	
	// 获取当前用户的诗歌草稿
	Model.prototype.poetryDataBeforeRefresh = function(event){
		event.source.setFilter("filter", "userId="+this.getContext().getRequestParameter("userId")+" and state=3 and status=1");
	};
	
	// 朗诵发布
	Model.prototype.rfbBtnClick = function(event){
		var self = this;
		var row = event.bindingContext.$object;
		this.comp("reciteData").setValue("state", 1, row);
		this.comp("reciteData").saveData({
			"onSuccess": function(event) {
				var poetryData = self.comp("rpData");
				poetryData.clear();
				poetryData.setFilter("filter", "poetryId="+row.val("poetryId"));
				poetryData.refreshData();
				poetryData.setValue("reciteCount", (poetryData.getValue("reciteCount") + 1));
				poetryData.saveData();
			}
		});
		this.comp("reciteData").refreshData();
	};
	
	// 朗诵删除
	Model.prototype.rDelBtnClick = function(event){
		var row = event.bindingContext.$object;
		this.comp("reciteData").setValue("state", 2, row);
		this.comp("reciteData").saveData();
		this.comp("reciteData").refreshData();
	};
	
	// 诗歌发布
	Model.prototype.pfbBtnClick = function(event){
		var row = event.bindingContext.$object; // 获取当前行对象
		this.comp("poetryData").setValue("state", 1, row);
		this.comp("poetryData").saveData();
		this.comp("poetryData").refreshData();
	};
	
	// 诗歌删除
	Model.prototype.pDelBtnClick = function(event){
		var row = event.bindingContext.$object; // 获取当前行对象
		this.comp("poetryData").setValue("state", 2, row);
		this.comp("poetryData").saveData();
		this.comp("poetryData").refreshData();
	};

	// 跳转朗诵发布详情页面
	Model.prototype.li6Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./fabuDetail.w?reciteId="+row.getID()+"&userId="+this.getContext().getRequestParameter("userId")));
	};

	// 跳转诗歌详情页面
	Model.prototype.li7Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./cgxEdit.w?poetryId="+row.getID()+"&userId="+this.getContext().getRequestParameter("userId")));
	};
	
	Model.prototype.modelActive = function(event){
		this.comp("reciteData").refreshData();
		this.comp("poetryData").refreshData();
	};
	
	Model.prototype.button4Click = function(event){
		common.getBackCount();
	};
	
	return Model;
});