define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var common = require("./common");
	require("$UI/system/lib/cordova/cordova");
	require("cordova!cordova-plugin-keyboard");
	//require("./js/jquery.lazyload.min");

	var Model = function(){
		this.callParent();
		this.userId;
		this.nickName;
		this.type = 2; // 查询类型，默认为朗诵
		this.text = ""; // 查询条件
		this.r = false;
		this.sroll0 = true;
		this.sroll1 = true;
	};
	
	// 查询
	Model.prototype.searchBtnClick = function(event){
		this.r = true;
		this.text = $("#"+this.getIDByXID("input1")).val(); 
		//this.text = this.comp("input1").val(); // 获取查询条件
		if(this.text == "" || this.text == undefined || this.text == null) {
			this.comp("alertDialog").set({message: '请输入查询内容'});
			this.comp("alertDialog").show();
			return false;
		}
		if (this.type == 1) { // 诗歌
			this.comp("poetryData").refreshData();
			//this.lazyLoad();
		} else { // 朗诵
			this.comp("reciteData").refreshData();
			//this.lazyLoad1();
		}
	};

	// 切换查询类型
	Model.prototype.select1Change = function(event){
		this.r = false;
		this.type = event.source.val(); // 获取查询类型
		if (this.type == 1) { // 诗歌
			$(".poetrys").addClass("hide");
			$(".recites").addClass("hide");
			$(".noData").addClass("hide");
			$(".tyList").removeClass("hide");
		} else { // 朗诵
			$(".poetrys").addClass("hide");
			$(".recites").addClass("hide");
			$(".noData").addClass("hide");
			$(".tyList").removeClass("hide");
		}
	};
	
	Model.prototype.reciteDataBeforeRefresh = function(event){
		if (this.r && this.type == 2) {
			if (this.text == "" || this.text == null || this.text == undefined) {
				event.source.setFilter("filter", "1=2");
			} else {
				event.source.setFilter("filter", "(INSTR(poetryTitle,'"+this.text+"')>0 or (INSTR(author,'"+this.text+"')>0) or (INSTR(reciteNickName,'"+this.text+"')>0)) and (state=1 or state=5) and status=1");
			}
		}
	};

	Model.prototype.reciteDataAfterRefresh = function(event){
		if (this.r && this.type == 2) {
			$(".tyList").addClass("hide");
			if (event.source.count() > 0) {
				$(".noData").addClass("hide");
				$(".recites").removeClass("hide");
			} else {
				$(".recites").addClass("hide");
				$(".noData").removeClass("hide");
				$(".zpm").text(this.text);
			} 
		}
	};
	
	Model.prototype.poetryDataBeforeRefresh = function(event){
		//event.source.clear();
		if (this.r && this.type == 1) {
			if (this.text == "" || this.text == null || this.text == undefined) {
				event.source.setFilter("filter", "1=2");
			} else {
				event.source.setFilter("filter", "(INSTR(title,'"+this.text+"')>0 or INSTR(author,'"+this.text+"')>0) and (state=1 or state=5) and status=1");
			}
		}
	};
	
	Model.prototype.poetryDataAfterRefresh = function(event){
		if (this.r && this.type == 1) {
			$(".tyList").addClass("hide");
			if (event.source.count() > 0) {
				$(".noData").addClass("hide");
				$(".poetrys").removeClass("hide");
			} else {
				$(".poetrys").addClass("hide");
				$(".noData").removeClass("hide");
				$(".zpm").text(this.text);
			}
		}
	};
	
	// 接收参数
	Model.prototype.modelParamsReceive = function(event){
		this.userId = this.getContext().getRequestParameter("userId");
	};

	// 跳转朗诵详情页面
	Model.prototype.li3Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./sdDetail.w?reciteId=" + row.getID() + "&userId=" + this.userId));
	};

	// 跳转诗歌详情页面
	Model.prototype.li2Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./ycsgDetail.w?poetryId=" + row.getID() + "&userId=" + this.userId));
	};
	
	//设置显示的时间格式
    Model.prototype.setTimeFormat = function(time) {
    	return common.durationToFormat(time);
    };
    
    // 获取头像
    Model.prototype.getHeadImg = function(str) {
    	return common.headUrl(str);
    };
    
	// 获取又拍云全路径
    Model.prototype.getImg = function(str) {
    	return common.imgUrl(str, "ph400");
    };
    
    // 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	str = common.textToBr(str);
    	var array = str.split("<br/>");
    	str = array[0] + "<br/>" + array[1] + "<br/>" + array[2] + "<br/>" + array[3] + "<br/>" + array[4] + "<br/>"; 
    	return str;
    };

	// 朗诵和朗诵上传时间操作
	Model.prototype.setUploadPosition = function(time) {
		return common.fbTimeToFormat(time);
	};


	// 相关推荐朗诵
	Model.prototype.tjReciteDataBeforeRefresh = function(event){
		event.source.setFilter("filter", "status =1 and state=5 and reciteUserId !="+this.getContext().getRequestParameter("userId"));
	};

	// 点击进入朗诵页面
	Model.prototype.readBtnClick = function(event){
		if (this.isToken()) {
			common.getHrefCount();
			var row = event.bindingContext.$object;
			justep.Shell.showPage(require.toUrl("./lslz.w?poetryId="+row.getID()), {userId: this.userId, nickName: this.nickName});
		}
	};
	
	// 判断token
	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};


	// 跳转无诗朗诵页面
	Model.prototype.button10Click = function(event){
		if (this.isToken()) {
			if (this.type == 1) { // 诗歌
				common.getHrefCount();
				justep.Shell.showPage(require.toUrl('./wyxs_wz.w'), {userId: this.userId, nickName: this.nickName});
			} else { // 朗诵
				common.getHrefCount();
				justep.Shell.showPage(require.toUrl("./wyxs.w"), {userId: this.userId, nickName: this.nickName});
			}
		}
	};

	// 跳转个人展示
	Model.prototype.span2Click = function(event){ // 朗诵
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("reciteUserId")));
	};
	Model.prototype.span58Click = function(event){ // 诗歌
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("userId")));
	};
    //软键盘搜索
	Model.prototype.input1Keydown = function(event){   
		if (event.keyCode == 13) {
			this.searchBtnClick();		
        }    
	};
	
//	Model.prototype.lazyLoad = function() {
//		$("li.lazy").lazyload({
//			effect : "show",
//			container: $(".lazyUl"),
//			failurelimit : 2,
//			load : function(e) {
//				$(this).removeClass("lazy");
//			}
//		});
//	};
//
//	Model.prototype.lazyLoad1 = function() {
//		$("li.lazy1").lazyload({
//			effect : "show",
//			container: $(".lazyUl1"),
//			failurelimit : 2,
//			load : function(e) {
//				$(this).removeClass("lazy1");
//			} 
//		});
//	};
//	Model.prototype.poetryScrollViewPullUp = function(event){
//		var self = this;
//		if (this.sroll0) {
//			setTimeout(function(){
//				self.lazyLoad();
//			}, 500);
//		}
//
//	};
//	Model.prototype.reciteScrollViewPullUp = function(event){
//		var self = this;
//		if (this.sroll1) {
//			setTimeout(function(){
//				self.lazyLoad1();
//			}, 500);
//		}
//	};
//	
//	
//	
//	Model.prototype.reciteScrollViewPullDown = function(event){
//		var self = this;
//			setTimeout(function(){
//				self.lazyLoad1();
//			}, 500);
//	};
//	
//	
//	
//	Model.prototype.poetryScrollViewPullDown = function(event){
//		var self = this;
//			setTimeout(function(){
//				self.lazyLoad();
//			}, 500);
//	};
//	
//	
//	
//	Model.prototype.poetryScrollViewScrollEnd = function(event){
//		var ss = $(".poetryScroll").find(".x-pull-up-label").text();
//		if (ss == "已经到最后.") {
//			this.sroll0 = false;
//		}
//	};
//	
//	
//	
//	Model.prototype.reciteScrollViewScrollEnd = function(event){
//		var ss = $(".reciteScroll").find(".x-pull-up-label").text();
//		if (ss == "已经到最后.") {
//			this.sroll1 = false;
//		}
//	};
//	

	
	Model.prototype.modelLoad = function(event){
	
	};	
	
	
	return Model;
});