define(function(require) {
	require("cordova!com.justep.cordova.plugin.qq");
	require("cordova!com.justep.cordova.plugin.weibo");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	var justep = require("$UI/system/lib/justep");
	var common = require("./common");
	require('./js/jquery.marquee.min');	
	var $ = require("jquery");

	var Model = function() {
		this.callParent();
		this.userId = 0;
		this.nickName;
		this.mediaRec;
		this.marquee;
		this.playPos;
		this.playState = 0; // 播放状态 0：待播放  1：播放中 2：暂停
		this.netTimer;
		this.play;
	};

	// 播放朗诵
	Model.prototype.playBtnClick = function(event) {
		var row = event.bindingContext.$object; // 获取当前行对象
		if (this.playState == 0) { // 开始播放
			this.playState = 1;
			this.playRecord(row.val("reciteTime"), row.val("url"), $(event.source.domNode).children());
			$(event.source.domNode).children().removeClass().addClass('linear linear-bullhorn');
			// 更新朗诵播放次数
			var data = this.comp("reciteData");
			data.setValue("listenCount", (data.getValue("listenCount", row) + 1), row);
			data.saveData();
		} else if (this.playState == 1) { // 暂停
			this.playState = 2;
			this.mediaRec.pause();
			this.marquee.marquee('pause');
			$(event.source.domNode).children().removeClass().addClass('linear linear-arrowrightcircle');
		} else if (this.playState == 2) { // 继续
			this.playState = 1;
			this.mediaRec.play();
			this.marquee.marquee('resume');
			$(event.source.domNode).children().removeClass().addClass('linear linear-bullhorn');
		}
	};
	
	// 录音播放
	Model.prototype.playRecord = function(reciteTime, url, $play) {
		this.play = $play;
		var self = this;
		this.mediaRec = new Media(self.getUrl(url), function(optio) {
			$(".play-jd").width("100%");
			self.playState = 0;
			clearInterval(self.netTimer);
			clearInterval(self.playPos);
			self.marquee.marquee('destroy');
			$(".play-jd").width("0px");
			$play.removeClass().addClass('linear linear-arrowrightcircle');
		}, function(err) {
			
		});
		this.mediaRec.play();
		
		// 显示诗词
		this.marquee = $(".marquee").bind('finished', function(){
	        //Change text to something else after first loop finishes
	        $(this).marquee('destroy');
		}).marquee({
		    //speed in milliseconds of the marquee
		    duration: reciteTime >=2 ? parseInt(reciteTime*400) : 300,
		    //gap in pixels between the tickers
		    gap: 50,
		    //time in milliseconds before the marquee will start animating
		    delayBeforeStart: 0,
		    //'left' or 'right'
		    direction: 'up',
		    //true or false - should the marquee be duplicated to show an effect of continues flow
		    duplicated: false
		});
		
		// 计算播放进度
		this.playPos = setInterval(function () {
			// get media position
			self.mediaRec.getCurrentPosition(
		        // success callback
		        function (position) {
		            if (position > 0) {
		            	$(".play-jd").width(((position/reciteTime)*100) + "%");
		            }
		        },
		        // error callback
		        function (e) {
		        }
		    );
		}, 100);
		
		// 定时监听网络制式
		var net = localStorage.getItem("wifiAlert");
		if (net == 'on') {
			this.netTimer = setInterval(function () {
				if (self.getNetWork() == '2g' || self.getNetWork() == '3g' || self.getNetWork() == '4g' || self.getNetWork() == 'cellular') {
					self.comp("netTimerDialog").show();
					clearInterval(self.netTimer);// 清空计时器
					self.playState = 2;
					self.mediaRec.pause();
					self.marquee.marquee('pause');
					$play.removeClass().addClass('linear linear-arrowrightcircle');
				}
			}, 1000);
		}
	};
	
	Model.prototype.netTimerDialogOK = function(event){
		this.playState = 1;
		this.mediaRec.play();
		this.marquee.marquee('resume');
		this.play.removeClass().addClass('linear linear-bullhorn');
	};
    
	Model.prototype.netTimerDialogCancel = function(event){
		this.closeMedia();
	};

	// 查询当前朗诵
	Model.prototype.reciteDataBeforeRefresh = function(event){
		var data = event.source;
		if (this.getContext().getRequestParameter("userId") != undefined && this.getContext().getRequestParameter("userId") != null) {
			this.userId = this.getContext().getRequestParameter("userId");
		}
		data.clear();
		data.filters.setVar("userId", this.userId);
		data.filters.setVar("reciteId", this.getContext().getRequestParameter("reciteId"));
	};
	
	// 判断用户是否登录
	Model.prototype.isToken = function() {
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		}
		return result.bool;
	};
	
	// 保存消息
	Model.prototype.saveMessage = function(userId, title, type) {
		if (userId != 0 && userId != undefined && userId != null && userId != this.userId) { // 判断当前用户是否为诗歌发布者
			var self = this;
			var messageData = this.comp("messageData");
			messageData.clear();
			messageData.newData({
				"defaultValues" : [ {
					"userId" : userId,
					"content" : "朗诵了您的诗歌 " + title,
					"state" : 1,
					"createTime" : new Date(),
					"type" : type,
					"pushUserId" : self.userId,
					"pushNickName" : self.nickName,
					"isRead" : 1
				} ]
			});
			messageData.saveData({
				"onSuccess" : function(event) {
					justep.Baas.sendRequest({
						"method" : "post",
						"url" : "/poetry/pjush",
						"action" : "sendMessage",
						"params" : {
							registrationId : "",
							tag : "",
							alias : userId,
							title : self.nickName + "朗诵了您的诗歌 " + title
						}
					});
				}
			});
		}
	};

	// 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	return common.textToBr(str);
    };
    
	// 获取又拍云全路径
    Model.prototype.getUrl = function(str) {
    	return common.imgUrl(str, "ph400");
    };
    
    //设置朗诵时长时间格式
    Model.prototype.setTimeFormat = function(time) {
    	return common.durationToFormat(time);
    };   
    
    // 获取网络
	Model.prototype.getNetWork = function() {
		return common.getNetWork();
	};
    
    // 发布
	Model.prototype.rediteBtnClick = function(event){
		if (this.isToken()) {
			this.comp("popOver1").show();
			var self = this;
			var data = this.comp("reciteData");
			data.setValue("state", 1);
			data.saveData({
				"onSuccess": function(event) {
					var poetryData = self.comp("poetryData");
					poetryData.clear();
					poetryData.setFilter("filter", "poetryId="+data.getValue("poetryId"));
					poetryData.refreshData();
					poetryData.setValue("reciteCount", (poetryData.getValue("reciteCount") + 1));
					poetryData.saveData();
					self.saveMessage(data.getValue("poetryUserId"), data.getValue("poetryTitle"), 6);
					self.comp("popOver1").hide();
					common.getBackCount();
					//justep.Shell.closePage();
					//justep.Shell.showPage(require.toUrl("./sdDetail.w?reciteId="+data.getCurrentRowID()+"&userId="+self.userId));
				}
			});
		}
	};
	
	// 判断用户是否登录
	Model.prototype.isToken = function() {
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};
    
    // 离开页面
	Model.prototype.modelInactive = function(event){
		this.closeMedia();
	};
	
	Model.prototype.closeMedia = function() {
		if (this.mediaRec != undefined || this.mediaRec != null) {
			this.mediaRec.stop();
		}
		this.playState = 0;
		clearInterval(this.netTimer);
		clearInterval(this.playPos);
		if (this.marquee != undefined || this.marquee != null) {
			this.marquee.marquee('destroy');
		}
		$(".play-jd").width("0px");
		if (this.play != undefined || this.play != null) {
			this.play.removeClass().addClass('linear linear-arrowrightcircle');
		}
	};

    
	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"padding-top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"padding-top":"20px"});
		}
		this.comp("popOver1").hide();
		this.comp("panel2").removeClass("hide");
	};

    
	Model.prototype.backBtnClick = function(event){
		common.getBackCount();
	};

    
	return Model;
});