define(function(require){
	var justep = require("$UI/system/lib/justep");
	var common = require("./common");
	var $ = require("jquery");
	
	var Model = function(){
		this.callParent();
		this.userId = 0;
		this.nickName = "";
	};

	// 初始
	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		this.fixed();
		this.isToken("init");
		
		var lookUserId = 0;
		if (this.getContext().getRequestParameter("userId") != null && this.getContext().getRequestParameter("userId") != undefined) {
			lookUserId = this.getContext().getRequestParameter("userId");
		}
		if (this.userId != lookUserId) {
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId="+this.userId+" and subUserId="+lookUserId);
			subData.refreshData();
			if (subData.count() > 0) {
				this.comp("subBtn").addClass("hide");
			} else {
				this.comp("subBtn").set({'label':'订阅'});
				this.comp("subBtn").removeClass("hide");
			}
		}
	};
	
	Model.prototype.fixed = function(event) {
		var hei0 = $('.topCon').outerHeight()
		var hei1 = $('.personTab .tab-content').offset().top;
		$('.personTab').css({
			'position' : 'fixed',
			'top' : hei0 + 'px',
			'padding-bottom' : hei1 + 'px'
		});
	};

	// 获取头像
    Model.prototype.getHeadImg = function(str) {
    	return common.headUrl(str);
    };

    // 获取用户信息
	Model.prototype.userDataBeforeRefresh = function(event){
		var lookUserId = 0;
		if (this.getContext().getRequestParameter("userId") != null && this.getContext().getRequestParameter("userId") != undefined) {
			lookUserId = this.getContext().getRequestParameter("userId");
		}
		var data = event.source;
		data.filters.setVar("userId", lookUserId);
	};
	
	// 朗诵查询
	Model.prototype.reciteDataBeforeRefresh = function(event){
		var lookUserId = 0;
		if (this.getContext().getRequestParameter("userId") != null && this.getContext().getRequestParameter("userId") != undefined) {
			lookUserId = this.getContext().getRequestParameter("userId");
		}
		event.source.setFilter("filter", "reciteUserId="+lookUserId+" and (state=1 or state=5) and status=1");
	};

	// 诗歌查询
	Model.prototype.poetryDataBeforeRefresh = function(event){
		var lookUserId = 0;
		if (this.getContext().getRequestParameter("userId") != null && this.getContext().getRequestParameter("userId") != undefined) {
			lookUserId = this.getContext().getRequestParameter("userId");
		}
		event.source.setFilter("filter", "userId="+lookUserId+" and (state=1 or state=5) and status=1");
	};

	// 跳转朗诵详情页
	Model.prototype.li5Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./sdDetail.w?reciteId="+row.getID()+"&userId="+this.userId));
	};
	
	// 朗诵和朗诵上传时间操作
	Model.prototype.setUploadPosition = function(time) {
		return common.fbTimeToFormat(time);
	};
	
	// 判断token
	Model.prototype.isToken = function(type) {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			if (type == "sub") {
				common.getHrefCount();
				justep.Shell.showPage(require.toUrl('./login.w'));
			}
		}
		return result.bool;
	};

	// 订阅、取消订阅
	Model.prototype.subBtnClick = function(event){
		var self = this;
		var object = event.source;
//		var label = object.label;
//		var xs = label == '订阅' ? '已订阅' : '订阅';
		if (this.isToken("sub")) {
			object.set({"disabled": true});
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId=" + self.userId + " and subUserId=" + this.getContext().getRequestParameter("userId"));
			subData.refreshData();
			if (subData.count() == 0) {
//			if (label == '订阅') {
				subData.newData({
					"defaultValues" :[{
						userId: self.userId,
						subUserId: self.getContext().getRequestParameter("userId"),
						createTime: new Date()
					}]
				});
				subData.saveData({
					"onSuccess": function(event) {
						object.set({"disabled": false});
						object.addClass("hide");
//						object.set({'label':xs});
						justep.Baas.sendRequest({
							"method" : "post",
							"url" : "/poetry/pjush",
							"action" : "sendMessage",
							"params" : {
								registrationId : "",
								tag : "",
								alias : self.getContext().getRequestParameter("userId"),
								title : self.nickName + "订阅了您"
							}
						});
					},"onError": function(event) {
						object.set({"disabled": false});
						object.addClass("hide");
					}
				});
			} else {
				object.set({"disabled": false});
				object.addClass("hide");
			}
//			else {
//				subData.clear();
//				subData.setFilter("filter", "userId="+this.userId+" and subUserId="+this.getContext().getRequestParameter("userId"));
//				subData.refreshData();
//				if (subData.count() > 0) {
//					subData.deleteData();
//					subData.saveData({
//						"onSuccess": function(event) {
//							object.set({'label':xs});
//						}
//					});
//				}
//			}
		}
		
	};

	// 跳转诗歌详情
	Model.prototype.li6Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./ycsgDetail.w?poetryId="+row.getID()+"&userId="+this.userId));
	};


	Model.prototype.backClick = function(event){
		common.getBackCount();
	};

	return Model;
});
define(function(require){
	var $ = require("jquery");
	var Model = function(){
		this.callParent();
	};
	Model.prototype.reciteDataBeforeRefresh = function(event){

	};

	return Model;
});
