define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	require("cordova!com.justep.cordova.plugin.weibo");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	require("cordova!cordova-plugin-device");
	require("cordova!cn.jpush.phonegap.JPushPlugin");
	require("./common");
	
	var Model = function(){
		this.callParent();
		this.type;
		this.info;
		this.username;
		this.password;
		this.userId;
		this.nickName;
	};

	// 微信授权
	Model.prototype.wxBtnClick = function(event){
		if (!navigator.weixin) {
			justep.Util.hint("请安装最新版本(含插件)体验！");
			return;
		};
		var self = this;
		var alertDialog = this.comp("alertDialog");
		function saveUser(data) {
			self.type = 1;
			self.info = data;
//			alert(JSON.stringify(data));
			self.getToken(data, 1, "", "", "");
		}

		navigator.weixin.ssoLogin(function() {
			navigator.weixin.getUserInfo(saveUser, function(reason) {
				if (reason != "cancel by user" && reason != "用户点击取消并返回") {
					alertDialog.set({message: "授权失败"});
					alertDialog.show();
				}
			});
		}, function(reason) {
			if (reason != "cancel by user" && reason != "用户点击取消并返回") {
				alertDialog.set({message: JSON.stringify(reason)});
				alertDialog.show();
			}
		});
	};

	// 微博授权
	Model.prototype.weiboBtnClick = function(event){
		if (!navigator.weibo) {
			justep.Util.hint("请安装最新版本(含插件)体验！");
			return;
		};

		var self = this;
		var alertDialog = this.comp("alertDialog");
		var onSuccess = function(info) {
			if (!info) {
				alertDialog.set({message: '授权信息获取失败'});
				alertDialog.show();
				return;
			}
			self.type = 2;
			self.info = info;
//			alert(JSON.stringify(info));
			self.getToken(info, 2, "", "", "");
		};

		navigator.weibo.ssoLogin(function() {
			navigator.weibo.getUserInfo(function(ret) {
				onSuccess(ret);
			}, function(ret) {
				if (ret != "cancel by user") {
					alertDialog.set({message: "授权失败"});
					alertDialog.show();
				}
			});
		}, function(info) {
			if (info != "cancel by user") {
				alertDialog.set({message: "授权失败"});
				alertDialog.show();
			}
		});
	};
	
	var getUrl = function(baseUrl, url, action){
		if(0===url.indexOf('http://')||0===url.indexOf('https://')) baseUrl = ''; 
		return baseUrl + url +"/"+action;
	};
	
	// 注册或登录并获取token
	Model.prototype.getToken = function(data, type, name, username, password){
		var self = this;
		var alertDialog = this.comp("alertDialog");
		var loginDialog = this.comp("loginDialog");
		var url = getUrl("/baas", "/poetry/user", "authLogin");
		var params = {
				userInfo : data,
				type : type,
				nick : name,
				username : username,
				password : password
			};
		$.ajax({
			"type" : "post",
			"dataType" : "json",
			"contentType" : "application/json",
			"url" : url,
			"data" : JSON.stringify(params),
			"success" : function(result) {
				self.comp("popOver3").hide();
			//	alert(JSON.stringify(result));
				if (result.state == 1) {
					localStorage.setItem("token", result.token);
					if (type == 3) {
						localStorage.setItem("bcuser", username);
						var ss = self.comp("checkbox1");
						if (ss.checked) {
							localStorage.setItem("bcpwd", password);
						} else {
							localStorage.removeItem("bcpwd");
						}
					}
					self.userId = result.userId;
					self.nickName = result.nickName;
					window.plugins.jPushPlugin.isPushStopped(function(data){
						if (data == 0) { // 启动
							window.plugins.jPushPlugin.getRegistrationID(function(registrationID) {
//								self.setTags(self.nickName);
							    self.setAlias(self.userId);
							});
						}
						loginDialog.set({message: '登录成功'});
						loginDialog.show();
					});
				} else if (result.state == "3") { // 昵称重复，跳转用户手动修改昵称页面
					alertDialog.set({message: '昵称已重复，请修改昵称'});
					alertDialog.show();
					self.comp("popOver1").show();
				} else if (result.state == "4") { // 认证失败(登录、token、签名等)
					alertDialog.set({message: '认证失败'});
					alertDialog.show();
				} else if (result.state == 5) { // 不存在（数据库查询不到）
					alertDialog.set({message: '用户不存在'});
					alertDialog.show();
				} else if (result.state == 6) { // 超时
					alertDialog.set({message: '网络超时，请稍后再试'});
					alertDialog.show();
				} else if (result.state == 7) { // 服务器错误
					alertDialog.set({message: '服务器错误，请稍后再试'});
					alertDialog.show();
				} else if (result.state == 8) { // 服务器异常
					alertDialog.set({message: '服务器异常，请稍后再试'});
					alertDialog.show();
				} else if (result.state == 10) { // 用户已被禁用
					alertDialog.set({message: '此用户已被禁用'});
					alertDialog.show();
				} else {
					alertDialog.set({message: '登录失败'});
					alertDialog.show();
				}
			},
			"error": function(result) {
				self.comp("popOver3").hide();
				alertDialog.set({message: '登录失败'});
				alertDialog.show();
			}
		});
	};
	
	Model.prototype.setAlias = function(alias) {
		if (window.plugins && window.plugins.jPushPlugin) {
			window.plugins.jPushPlugin.setAlias(alias);
		}
	};

	Model.prototype.setTags = function(tags) {
		if (window.plugins && window.plugins.jPushPlugin) {
			window.plugins.jPushPlugin.setTags(tags);
		}
	};

	// 保存
	Model.prototype.button2Click = function(event){
		var name = $.trim(this.comp("input1").val());
		if (name == "" || name == null || name == undefined) {
			var alertDialog = this.comp("alertDialog");
			alertDialog.set({message: '请输入昵称'});
			alertDialog.show();
			return false;
		}
		this.comp("input1").clear();
		this.comp("popOver1").hide();
		this.comp("popOver3").show();
		this.getToken(this.info, this.type, name, this.username, this.password);
	};
	
	// 取消
	Model.prototype.button1Click = function(event){
		this.comp("popOver1").hide();
	};

	Model.prototype.syxyClick = function(event){
		this.comp("popOver2").show();
	};

	Model.prototype.closeClick = function(event){
		this.comp("popOver2").hide();
	};
	
	// 微博返回信息  id：唯一标识、name：昵称、gender：m性别、profile_image_url:头像

	// 博客中国登录
	Model.prototype.loginBtnClick = function(event){
		var alertDialog = this.comp("alertDialog");
		var username = this.comp("account").val();
		if (username == "" || username == null || username == undefined) {
			alertDialog.show({message: '请输入数用户名手机号或者邮箱'});
			return;
		}
		var password = this.comp("password").val();
		if (password == "" || password == null || password == undefined) {
			alertDialog.show({message: '请输入密码'});
			return;
		}
		this.comp("popOver3").show();
		this.type = 3;
		this.username = username;
		this.password = password;
		this.getToken(null, 3, "", username, password);
	};

	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		if (localStorage.getItem("bcpwd") != null && localStorage.getItem("bcpwd") != undefined) {
			this.comp("checkbox1").set("checked", true);
			this.comp("password").val(localStorage.getItem("bcpwd"));
		} else {
			this.comp("checkbox1").set("checked", false);
		}
		this.comp("account").val(localStorage.getItem("bcuser"));
	};

	Model.prototype.checkbox1Change = function(event){
		if (event.source.checked) {
			event.source.set("checked", false);
		} else {
			event.source.set("checked", true);
		}
	};

	Model.prototype.alertDialogOK = function(event){
		this.close();
	};

	Model.prototype.button3Click = function(event){
		common.getBackCount();
	};

	return Model;
});