define(function(require){
	require("css!./swiper/dist/css/swiper.min").load();
	require("cordova!cordova-plugin-media");
	require("cordova!cordova-plugin-file");
	require("cordova!cordova-plugin-insomnia");
	require("./swiper/dist/js/swiper.min");
	require('./js/jquery.marquee.min');
	var justep = require("$UI/system/lib/justep");
	var voice = require('./voice');
	var common = require("./common");
	var $ = require("jquery");

	var Model = function(){
		this.callParent();
		this.poetryId = 0;
		this.userId;
		this.nickName;
		this.timeLen;
		this.mediaTimer;
		this.recTime;
		this.recordState = 0;
		this.url;
		this.mediaRec;
		this.marquee;
		this.plaTime;
		this.playTimer;		
		this.address; 
		this.longitude;
		this.latitude;
		this.state = 1;
		this.nick = justep.Bind.observable("");
		this.backgroundUrl;
		this.type;
		this.netTimer;
	};

	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		this.comp("popOver1").hide();
		this.comp("panel1").removeClass("hide");
		this.comp("panelDelete").removeClass("hide");
		document.addEventListener("deviceready", this.onDeviceReady.bind(this), false);
	};
	
	Model.prototype.onDeviceReady = function() {
		plugins.insomnia.keepAwake(function(){
//	        justep.Util.hint("设置常亮成功");
	    }, function(){
//	        justep.Util.hint("设置失败");
	    });
	};

	// 接收参数
	Model.prototype.modelParamsReceive = function(event){
		this.poetryId = this.getContext().getRequestParameter("poetryId");
		this.userId = event.params.userId;
		this.nickName = event.params.nickName;
		this.nick.set(this.nickName);
	};
	
	// 获取背景图
    Model.prototype.getImg = function(str) {
    	return common.imgUrl(str, "pwh90");
    };
    Model.prototype.getImg1 = function(str) {
    	return common.imgUrl(str, "ph400");
    };
    
    // 添加参数条件
	Model.prototype.poetryDataBeforeRefresh = function(event){
		if (this.getContext().getRequestParameter("poetryId") != null && this.getContext().getRequestParameter("poetryId") != undefined) {
			this.poetryId = this.getContext().getRequestParameter("poetryId");
		}
		event.source.clear();
		event.source.setFilter("filter", "poetryId="+this.poetryId);
	};

	// 开始录音、播放、暂停
	Model.prototype.startRecordBtnClick = function(event){
		var me = this;
		if (me.recordState == 0) { // 开始录音
			me.recordState = 1;
			me.comp("recordTime").set({value : "00:00/06:00"});
			$(".recordDescription").text("录音中");
			
			// 定位
			var gpsDtd = common.getGeo();
			gpsDtd.done(function(position) {
				me.address = position.address;
				me.longitude = position.longitude;
				me.latitude = position.latitude;
			});
			
			// 开始录音
			voice.startRecord({
				cancel:function(){}
			});
			me.recTime = 0;
			me.mediaTimer = setInterval(function() {
				if (me.recTime > 359) {
					me.recordState = 2;
					me.state = 1;
					clearInterval(me.mediaTimer);// 清空计时器
					//me.comp("recordTime").set({value : common.durationToFormat(me.recTime)});
					$(".ly").removeClass("linear linear-mic").addClass("dataControl dataControl-arrowrightl");
					$(".recordDescription").text("试听");
					$(".action").removeClass("hide");
					// 停止录音
					voice.stopRecord({
						success : function(res) {
							me.url = res.localId;
						},
						fail : function(res) {}
					});
					return;
				}
				me.recTime = me.recTime + 1;
	            me.setAudioPosition(me.recTime);
	            me.comp("recordTime").set({value : me.timeLen+"/06:00"});
			}, 1000);
			
		} else if (me.recordState == 1) { // 结束录音
			me.recordState = 2;
			me.state = 1;
			clearInterval(me.mediaTimer);// 清空计时器
			//me.comp("recordTime").set({value : common.durationToFormat(me.recTime)});
			$(".ly").removeClass("linear linear-mic").addClass("dataControl dataControl-arrowrightl");
			$(".recordDescription").text("试听");
			$(".action").removeClass("hide");
			
			// 停止录音
			voice.stopRecord({
				success : function(res) {
					me.url = res.localId;
				},
				fail : function(res) {}
			});
			
		} else if (me.recordState == 2) { // 播放
			
			me.recordState = 3;
			$(".ly").removeClass("dataControl-arrowrightl").addClass("dataControl-pausel");
			$(".recordDescription").text("播放中");
			
			// 播放音频
			me.mediaRec = new Media(me.url, function(option) {
				if (me.state == 1) {
					me.recordState = 2;
					clearInterval(me.netTimer);// 清空计时器
					clearInterval(me.playTimer);// 清空计时器
					me.comp("recordTime").set({value : me.timeLen});
					$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
					$(".recordDescription").text("试听");
					me.marquee.marquee('destroy');
					me.mediaRec.release();
					me.mediaRec = null;
				}
			}, function(err) {});
			me.mediaRec.play();
			
			me.plaTime = 0;
			me.playTimer = setInterval(function() {
				me.plaTime = me.plaTime + 1;
	            me.setAudioPosition(me.plaTime);
	            me.comp("recordTime").set({value : me.timeLen});
			}, 1000);
			
			me.marqueePoetry(); // 滚动文字
			
			// 定时监听网络制式
			var net = localStorage.getItem("wifiAlert");
			if (net == 'on') {
				me.netTimer = setInterval(function() {
					if (me.getNetWork() == '2g' || me.getNetWork() == '3g' || me.getNetWork() == '4g' || me.getNetWork() == 'cellular') {
						me.comp("netTimerDialog").show();
						me.recordState = 4;
						clearInterval(me.netTimer);// 清空计时器
						clearInterval(me.playTimer);// 清空计时器
						$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
						$(".recordDescription").text("暂停");
						me.mediaRec.pause();
						me.marquee.marquee('pause');
					}
				}, 1000);
			}
		
		} else if (me.recordState == 3) { // 暂停
			
			me.recordState = 4;
			clearInterval(me.playTimer);// 清空计时器
			$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
			$(".recordDescription").text("暂停");
			
			me.mediaRec.pause();
			me.marquee.marquee('pause');
		
		} else if (me.recordState == 4) { // 继续播放
			
			me.recordState = 3;
			$(".ly").removeClass("dataControl-arrowrightl").addClass("dataControl-pausel");
			$(".recordDescription").text("播放中");
			me.playTimer = setInterval(function() {
				me.plaTime = me.plaTime + 1;
	            me.setAudioPosition(me.plaTime);
	            me.comp("recordTime").set({value : me.timeLen});
			}, 1000);
			me.mediaRec.play();
			me.marquee.marquee('resume');
		}
	};
	Model.prototype.netTimerDialogOK = function(event){
		this.recordState = 3;
		$(".ly").removeClass("dataControl-arrowrightl").addClass("dataControl-pausel");
		$(".recordDescription").text("播放中");
		this.playTimer = setInterval(function() {
			this.plaTime = this.plaTime + 1;
            this.setAudioPosition(this.plaTime);
            this.comp("recordTime").set({value : this.timeLen});
		}, 1000);
		this.mediaRec.play();
		this.marquee.marquee('resume');
	};
	Model.prototype.netTimerDialogCancel = function(event){
		this.recordState = 2;
		clearInterval(this.playTimer);// 清空计时器
		this.comp("recordTime").set({value : "00:00:00"});
		$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
		$(".recordDescription").text("试听");
		this.marquee.marquee('destroy');
		this.mediaRec.stop();
	};
	
    // 重录
	Model.prototype.resetBtnClick = function(event){
		this.resetRecode();
	};
	
	//设置显示的时间
    Model.prototype.setAudioPosition = function(position) {
    	var hour = parseInt(position / 3600);// 小时数
		var min = parseInt(position / 60);// 分钟数
		if (min >= 60) {
			min = min % 60;
		}
		var lastsecs = position % 60;
		if(hour < 10) hour = "0" + hour;
		if(min < 10) min = "0" + min;
		if(lastsecs < 10) lastsecs = "0" + lastsecs;
		
		this.timeLen = min + ':' + lastsecs;
    };
    
    // 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	if (str != "" && str != null && str != undefined) {
    		return common.textToBr(str);
    	} else {
    		return "";
    	}
    };
    
    // 滚动文字
    Model.prototype.marqueePoetry = function() {
    	var self = this;
		// 显示诗词
		this.marquee = $(".marquee").bind('finished', function(){
	        //Change text to something else after first loop finishes
	        $(this).marquee('destroy');
		}).marquee({
		    //speed in milliseconds of the marquee
		    duration: self.recTime >=2 ? parseInt(self.recTime*500) : 300,
		    //gap in pixels between the tickers
		    gap: 50,
		    //time in milliseconds before the marquee will start animating
		    delayBeforeStart: 0,
		    //'left' or 'right'
		    direction: 'up',
		    //true or false - should the marquee be duplicated to show an effect of continues flow
		    duplicated: false
		});
    };
    
    // 初始参数
    Model.prototype.resetRecode = function() {
    	this.recordState = 0;
    	clearInterval(this.netTimer);// 清空计时器
		clearInterval(this.playTimer);// 清空计时器
		clearInterval(this.mediaTimer);// 清空计时器
		this.comp("recordTime").set({value : ""});
		$(".recordDescription").text("按一下开始录音");
		$(".ly").removeClass("dataControl dataControl-arrowrightl dataControl-pausel").addClass("linear linear-mic").css('margin-left','0px');
		$(".action").addClass("hide");
		this.timeLen = "";
		this.recTime = 0;
		this.url = "";
		this.plaTime = 0;
		this.address = 0;
		this.longitude = 0;
		this.latitude = 0;
		this.state = 0;
		if (this.mediaRec != null || this.mediaRec != undefined) {
			this.mediaRec.stop();
			this.mediaRec.release();
			this.marquee.marquee('destroy');
		}
		voice.stopRecord({
			success : function(res) {},
			fail : function(res) {}
		});
    };

    // 下一步
	Model.prototype.nextBtnClick = function(event){
		if (this.recTime <= 10) {
			var alertDialog = this.comp("alertDialog");
			alertDialog.set({message: '录制时间太短，多诵读两句再保存吧！'});
			alertDialog.show();
			return false;
		}
		var self = this;
		var recite = {};
		recite.poetryId = this.poetryId;
		recite.url = this.url;
		recite.recTime = this.recTime;
		recite.address = this.address;
		recite.longitude = this.longitude;
		recite.latitude = this.latitude;
		localStorage.setItem("recite", JSON.stringify(recite));
		var data = {
			userId: this.userId, 
			nickName: this.nickName,
			type: 2
		};
		this.state = 0;
		this.resetRecode();
		$(".ssss").removeClass("hide");
		this.comp("contents1").to("fabu", function(){
			var swiper = new Swiper('.swiper-container', {
				slidesPerView : 3,
				centeredSlides : true,
				paginationClickable : true,
	//			spaceBetween : 15,
				loop:true,
			});
			$('.swiper-wrapper li').css('width','');
			
			// 选择背景图
			$(".choice-img").click(function(){
				var bgurl = $(this).attr("src");
				self.backgroundUrl = bgurl.split("!")[0] + "!ph400";
				$(".backImg").css("background-image", "url("+self.backgroundUrl+")");
				
			});
		});
//		justep.Shell.showPage(require.toUrl("./scly.w"), data);
	};

	// 发布
	Model.prototype.fbButtonClick = function(event){
		var alertDialog = this.comp("alertDialog");
		if (this.backgroundUrl == null || this.backgroundUrl == undefined || this.backgroundUrl == "") {
			alertDialog.set({message:"请选择背景图片！"});
			alertDialog.show();
			return false;
		}
		if (localStorage.getItem("recite") == null && localStorage.getItem("recite") == undefined) {
			alertDialog.set({message:"请先返回上一页面录制诗歌！"});
			alertDialog.show();
			return false;
		}
		this.saveRecord(1);
	};
    //form 表单上传 测试
//    Model.prototype.formUp=function(type){
//    var fileName = justep.Date.toString(new Date(), "yyyyMMddhhmmss") + ".wav";
//    curl=" http://v0.api.upyun.com/bokeestorepic3\-F @<filename>\-F policy=<policy>"
//    {"bucket":"bokeestorepic3","expiration":1409200758,"save-key":"/poetry_bokee/" + type+ "/" + this.userid + "/" + params.get("fileName")}
//    }
//    
    
    
	Model.prototype.saveRecord = function(type) {
		this.type = type;
		if (this.isToken()) {
			if (this.getNetWork() == '2g' || this.getNetWork() == '3g' || this.getNetWork() == '4g' || this.getNetWork() == 'cellular') {
				this.comp("netWorkDialog").show();
			} else {
				this.uploadRecord(type);
			}
		}
	};
	Model.prototype.netWorkDialogOK = function(event){
		this.uploadRecord(this.type);
	};
	Model.prototype.uploadRecord = function(type) {	
		this.comp("popOver1").show();
		var self = this;
		var recite = JSON.parse(localStorage.getItem("recite"));
		var poetryData = this.comp("poetryData");
		var reciteData = this.comp("reciteData");
		reciteData.clear();
		// 上传录音
		voice.uploadVoice({
			localId : recite.url,
			userId : self.userId,
			fileType : "mic",
			success : function(res) {
				var data = res.serverId;
				reciteData.newData({
					defaultValues : [ {
						poetryId : recite.poetryId,// 诗歌ID
						url : data.fileUrl,// 路径
						reciteUserId : self.userId,// 朗诵者ID
						poetryUserId : poetryData.getValue("userId"),// 诗歌发布者ID
						state : type,// 状态
						listenCount : 0,// 收听次数
						address : recite.address,// 定位地址
						commentCount : 0,// 评论数量
						retransmissionCount : 0,// 转发数量
						longitude : recite.longitude,// 经度
						latitude : recite.latitude,//纬度
						reciteTime : recite.recTime,// 朗诵时长
						uploadTime : new Date(),// 上传时间
						backgroundImg : (self.backgroundUrl.toString().split(".com")[1]).split("!")[0],// 背景图
						reciteNickName : self.nickName,// 朗诵者昵称
						poetryTitle : poetryData.getValue("title"),// 诗歌标题
						poetryNickName : poetryData.getValue("nickName"),// 诗歌发布者昵称
						author : poetryData.getValue("author"),// 诗作者
						type : (self.comp("checkbox1").checked ? 2 : 1), // 分类
						status :1
					} ]
				});
				reciteData.saveData({
					"onSuccess": function(event) {
						localStorage.removeItem("recite");
						self.saveMessage(type);
						self.comp("popOver1").hide();
						var sss = type == 3 ? "已存入草稿箱" : "恭喜您，发布成功";
						self.comp("fbSuccessDialog").show({message:sss});
					}
				});
			}
		});
	};
	
	// 存草稿箱
	Model.prototype.cgButtonClick = function(event) {
		var alertDialog = this.comp("alertDialog");
		if (this.backgroundUrl == null || this.backgroundUrl == undefined) {
			alertDialog.set({message:"请选择背景图片！"});
			alertDialog.show();
			return false;
		}
		if (localStorage.getItem("recite") == null && localStorage.getItem("recite") == undefined) {
			alertDialog.set({message:"请先返回上一页面录制诗歌！"});
			alertDialog.show();
			return false;
		}
		this.comp('cgxDialog').show();
	};
	Model.prototype.cgxDialogOK = function(event){
		this.saveRecord(3);
	};
	
	// 保存相关信息
	Model.prototype.saveMessage = function(type) {
		// 诗歌被朗诵数加一
		if (type == 1) {
			var poetryData = this.comp("poetryData");
			poetryData.setValue("reciteCount", (poetryData.getValue("reciteCount") + 1));
			poetryData.setValue("reciteLastTime", new Date());
			poetryData.saveData();
			
			var self = this;
			//保存消息
			var uid = poetryData.val("userId");
			if (uid != 0 && uid != self.userId) {
				var messageData = self.comp("messageData");
				messageData.clear();
				messageData.newData({
					"defaultValues" : [ {
						"userId" : uid,
						"content" : "朗诵了您的诗歌 " + poetryData.val("title"),
						"state" : 1,
						"createTime" : new Date(),
						"type" : 6,
						"pushUserId" : self.userId,
						"pushNickName" : self.nickName,
						"isRead" : 1
					} ]
				});
				messageData.saveData({
					"onSuccess" : function(event) {
						justep.Baas.sendRequest({
							"method" : "post",
							"url" : "/poetry/pjush",
							"action" : "sendMessage",
							"params" : {
								registrationId : "",
								tag : "",
								alias : uid,
								title : self.nickName + "朗诵了您的诗歌 " + poetryData.val("title")
							}
						});
					}
				});
			}
		}
	};
	
	// 判断token
	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};

	// 发布成功
	Model.prototype.fbSuccessDialogOK = function(event){
		justep.Shell.closePage();
	};

	// 获取网络
	Model.prototype.getNetWork = function() {
		return common.getNetWork();
	};

	// 离开页面
	Model.prototype.modelInactive = function(event){
		this.resetRecode();
		plugins.insomnia.allowSleepAgain(function(){
//	        justep.Util.hint("设置自动息屏成功");
	    }, function(){
//	        justep.Util.hint("设置失败");
	    });
	};

	// 返回
	Model.prototype.backBtnClick = function(event){
		if (this.url != null && this.url != undefined) {
			this.comp("backDialog").show();
		} else {
			common.getBackCount();
		}
	};
	Model.prototype.backDialogOK = function(event){
		justep.Shell.closePage();
	};

	Model.prototype.checkbox1Change = function(event){
		if (event.source.checked) {
			event.source.set({"checked": false});
		} else {
			event.source.set({"checked": true});
		}
	};


	Model.prototype.button2Click = function(event){
		this.close();
	};


	return Model;
});