define(function(require) {
	var $ = require("jquery");
//	require("$UI/poetry/swiper/dist/js/swiper.min");
//	require("css!./swiper/dist/css/swiper.min").load();
	require("./owlcarousel/owl.carousel.min")
	require("css!./owlcarousel/owl.carousel.min").load();
	var justep = require("$UI/system/lib/justep");
	require("cordova!cordova-plugin-device");
	require("cordova!cn.jpush.phonegap.JPushPlugin");
	var common = require("./common");
	var loading = require("./loadding");

	var Model = function() {
		this.callParent();
		this.userId = 0;
		this.nickName;
		this.registrationID;
		this.first = true;
		this.owl;
	};
	
	Model.prototype.owlFunction = function(type) {
		if (type == 'new') {
			$(".owl-carousel").owlCarousel({
				singleItem:true,
				pagination:false,
				navigationText:false
			});
			this.owl = $(".owl-carousel").data('owlCarousel');
		} else {
			this.owl.reinit({
				singleItem:true,
				pagination:false,
				navigationText:false
			});
		}
	};

	// 初始滑动效果
	Model.prototype.model2Load = function(event) {
//		localStorage.removeItem("token");
		$(".loadingDiv").addClass("hide");
		$(".tjlist").removeClass("hide");
		this.owlFunction('new');
		
		if (this.isToken() && this.first) {
			var self = this;
			this.first = false;
			document.addEventListener("deviceready", self.onDeviceReady.bind(this), false);
			document.addEventListener("jpush.receiveNotification", self.onReceiveNotification.bind(this), false);
			document.addEventListener("jpush.receiveMessage", self.onReceiveMessage.bind(this), false);

			var count = localStorage.getItem("noReadMessage");
			if (count != null && count != undefined && count > 0) {
				$(".news").removeClass("hide");
			}
		}
	};

	Model.prototype.onDeviceReady = function() {
		window.plugins.jPushPlugin.init();
		var self = this;
		window.plugins.jPushPlugin.getRegistrationID(function(registrationID) {
			self.registrationID = registrationID;
			//			set.TagsWithAlias(self.nickName, self.userId);
			self.setTags(self.nickName);
			self.setAlias(self.userId);
		});
		//		window.plugins.jPushPlugin.setDebugMode(false);
		//		window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);

	};

	Model.prototype.setTags = function(tags) {
		if (window.plugins && window.plugins.jPushPlugin) {
			window.plugins.jPushPlugin.setTags(tags);
		}
	};

	Model.prototype.setAlias = function(alias) {
		if (window.plugins && window.plugins.jPushPlugin) {
			window.plugins.jPushPlugin.setAlias(alias);
		}
	};

	Model.prototype.setTagsWithAlias = function(tags, alias) {
		if (window.plugins && window.plugins.jPushPlugin) {
			window.plugins.jPushPlugin.setTagsWithAlias(tags, alias);
		}
	};

	Model.prototype.onReceiveNotification = function(event) {
		var alertContent;
		if (device.platform == "Android") {
			alertContent = window.plugins.jPushPlugin.receiveNotification.alert;
		} else {
			alertContent = event.aps.alert;
		}
		var token = localStorage.getItem("token");
		if (token == null || token == undefined) {
			localStorage.setItem("noReadMessage", "1");
		} else {
			$('.news').removeClass("hide");
		}
		//        window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		//        alert("2" + alertContent);
	};

	Model.prototype.onReceiveMessage = function() {
		var message;
		if (device.platform == "Android") {
			message = window.plugins.jPushPlugin.receiveMessage.message;
		} else {
			message = event.content;
		}
		//        alert(message);
		var token = localStorage.getItem("token");
		if (token == null || token == undefined) {
			localStorage.setItem("noReadMessage", "1");
		} else {
			$('.news').removeClass("hide");
		}
		//        window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		//        alert("3" + message);
	};
	
	// 获取背景图
	Model.prototype.getImg = function(str) {
		return common.imgUrl(str);
	};

	// 获取未删除状态诗歌
	Model.prototype.poetryDataBeforeRefresh = function(event) {
		event.source.setFilter("filter", "(state=1 or state=5)");
	};
	
	// 点击诗歌，跳转诗歌朗诵列表页面
	Model.prototype.li1Click = function(event) {
		var row = event.bindingContext.$object; // 获取当前行对象
		if (row.val("reciteCount") > 0) {
			justep.Shell.showPage(require.toUrl('./sglsList.w?poetryId=' + row.val("poetryId") + '&userId=' + this.userId + "&title=" + row.val("title")));
		} else {
			justep.Shell.showPage(require.toUrl("./ycsgDetail.w?poetryId=" + row.val("poetryId") + "&userId=" + this.userId));
		}
	};

	// 朗诵页面
	Model.prototype.button1Click = function(event) {
		var i = parseInt(Math.random() * 49);
		var id = $(".swiper-slide:eq(" + i + ")").attr("value");
		justep.Shell.showPage(require.toUrl('./search.w?tjPoetryId=' + id), {
			userId : this.userId
		});
	};
	
	// 推荐页面
	Model.prototype.jxBtnClick = function(event){
		var self = this;
//		this.owl.destroy();
		this.comp("poetryTjData").refreshData({
			'onSuccess': function(event) {
				self.owlFunction('update');
			}
		});
	};

	// 加载我的页面
	Model.prototype.wdBtnClick = function(event) {
		if (this.isToken()) {
		    localStorage.removeItem("noReadMessage");
			$(".news").addClass("hide");
			var container = this.comp("wdContainer");
				container.load(require.toUrl("./wd.w?userId=" + this.userId), {
				nickName : this.nickName
			});
		} else {
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
	};

	// 加载发现页面
	Model.prototype.xxBtnClick = function(event) {
//		if (this.isToken()) {
			var container = this.comp("xxContainer");
			container.load(require.toUrl("./find.w?userId=" + this.userId));
//		} else {
//			justep.Shell.showPage(require.toUrl('./login.w'));
//		}
	};

	// 加载订阅页面
	Model.prototype.dyBtnClick = function(event) {
		//loading.load();
//		justep.Shell.showPage(require.toUrl('./mainActivity.w'));
		if (this.isToken()) {
			var data = this.comp("subscribeData");
			data.setFilter("filter", "userId=" + this.userId);
			data.refreshData();
			var count = data.count();
			var container = this.comp("dyContainer");
			if (count < 1) {
				var i = parseInt(Math.random() * 49);
				var id = $(".swiper-slide:eq(" + i + ")").attr("value");

				justep.Shell.showPage(require.toUrl('./dysearch.w?userId=' + this.userId));
			} else {
				container.load(require.toUrl("./dy.w?userId=" + this.userId));
			}
		} else {
		
			justep.Shell.showPage(require.toUrl('./dysearch.w?userId=' + this.userId));
		}
	};

	// 跳转登录页面
	Model.prototype.loginBtnClick = function(event) {
		justep.Shell.showPage(require.toUrl('./login.w'));
	};

	Model.prototype.model2Active = function(event) {
		var token = this.isToken();
		var contents = this.comp("index");
		var active = contents.getActiveIndex();
		if (active == 0) { // 精选
			var self = this;
//			this.owl.destroy();
			this.comp("poetryTjData").refreshData({
				'onSuccess': function(event) {
					self.owlFunction('update');
				}
			});
			
		} else if (active == 1) { // 订阅
			if (token) {
				var data = this.comp("subscribeData");
				data.setFilter("filter", "userId=" + this.userId);
				data.refreshData();
				if (data.count() > 0) {
//					var container = this.comp("dyContainer");
//					container.refresh(require.toUrl("./dy.w?userId=" + this.userId));
				} else {
					contents.to("jxContent");
				}
			} else {
				contents.to("jxContent");
			}
		} else if (active == 2) { // 消息
//			if (token) {
				var container = this.comp("xxContainer");
				container.refresh(require.toUrl("./find.w?userId=" + this.userId));
//			} else {
//				contents.to("jxContent");
//			}
		} else if (active == 3) { // 我的
			if (token) {
				var container = this.comp("wdContainer");
				container.refresh(require.toUrl("./wd.w?userId=" + this.userId), {
					nickName : this.nickName
				});
			} else {
				contents.to("jxContent");
			}
		}
	};

	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		}
		return result.bool;
	};

	Model.prototype.indexActiveChanged = function(event){
		var contents = this.comp("index");
		var active = contents.getActiveIndex();
		var jxBtn = this.comp('jxBtn');
		var dyBtn = this.comp('dyBtn');
		var xxBtn = this.comp('xxBtn');
		var wdBtn = this.comp('wdBtn');
		if(active === 0){
			jxBtn.set({
				"icon" : "img:$UI/poetry/img/jx1.png|"
			});

			jxBtn.addClass("one");
			jxBtn.removeClass("two");
			dyBtn.set({
				"icon" : "img:$UI/poetry/img/dy.png|"
			});

			dyBtn.addClass("two");
			dyBtn.removeClass("one");
			xxBtn.set({
				"icon" : "img:$UI/poetry/img/xx.png|"
			});
			xxBtn.addClass("two");
			xxBtn.removeClass("one");
			wdBtn.set({
				"icon" : "img:$UI/poetry/img/wd.png|"
			});
			wdBtn.addClass("two");
			wdBtn.removeClass("one");
		}
		if(active === 1){
			jxBtn.set({
				"icon" : "img:$UI/poetry/img/jx.png|"
			});
			jxBtn.addClass("two");
			jxBtn.removeClass("one");
			dyBtn.set({
				"icon" : "img:$UI/poetry/img/dy1.png|"
			});
			dyBtn.addClass("one");
			dyBtn.removeClass("two");
			xxBtn.set({
				"icon" : "img:$UI/poetry/img/xx.png|"
			});
			xxBtn.addClass("two");
			xxBtn.removeClass("one");
			wdBtn.set({
				"icon" : "img:$UI/poetry/img/wd.png|"
			});
			wdBtn.addClass("two");
			wdBtn.removeClass("one");
		}
		if(active === 2){
				jxBtn.set({
					"icon" : "img:$UI/poetry/img/jx.png|"
				});
			jxBtn.addClass("two");
			jxBtn.removeClass("one");
				dyBtn.set({
					"icon" : "img:$UI/poetry/img/dy.png|"
				});
				dyBtn.addClass("two");
			dyBtn.removeClass("one");
				xxBtn.set({
					"icon" : "img:$UI/poetry/img/xx1.png|"
				});
			xxBtn.addClass("one");
			xxBtn.removeClass("two");
			wdBtn.set({
				"icon" : "img:$UI/poetry/img/wd.png|"
			});
			wdBtn.addClass("two");
			wdBtn.removeClass("one");
		}
		if(active === 3){
				jxBtn.set({
				"icon" : "img:$UI/poetry/img/jx.png|"
			});
			jxBtn.addClass("two");
			jxBtn.removeClass("one");
				dyBtn.set({
				"icon" : "img:$UI/poetry/img/dy.png|"
			});
			dyBtn.addClass("two");
			dyBtn.removeClass("one");
			xxBtn.set({
				"icon" : "img:$UI/poetry/img/xx.png|"
			});
			xxBtn.addClass("two");
			xxBtn.removeClass("one");
				wdBtn.set({
				"icon" : "img:$UI/poetry/img/wd1.png|"
			});
			wdBtn.addClass("one");
			wdBtn.removeClass("two");
		}
		
	};


	Model.prototype.li1Touchmove = function(event){
		this.litouch();
	};

	Model.prototype.backBtnClick = function(event){
		this.swiper.slideTo(0, 1000, false);
		this.litouch();
	};




	Model.prototype.litouch = function(event){
		var index=this.swiper.activeIndex;
			if(this.swiper.activeIndex>0){
				$('.backBtn').removeClass('hide');
			};
			if(this.swiper.activeIndex<1){
				$('.backBtn').addClass('hide')
			}
	};




	return Model;
});