define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
    var common = require("./common");
    
	var Model = function(){
		this.callParent();
	};
	
	// 定义全局变量
    var style=1;
    var replyId=0;
    var level=1;
    var objectNickName;
    var objectUserId;

	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		this.open();
//		$(".plContent").removeClass("hide");
		this.comp("plContent").removeClass("hide");
		$(".loadingDiv").addClass("hide");
	};
	
	Model.prototype.getCreateTime = function(time){
		return common.fbTimeToFormat(time);
	};
	//多条信息隐藏或显示
	Model.prototype.open = function(event) {
		$(".ul-box").each(function(i) {
			$(this).find('.pl-area').each(function() {
				var len1 = $(this).children('.eli').length;
				var str = "";
				if (len1 > 2) {
					str = "<span class='moreRe' style='font-family:Microsoft Yahei;font-size:14px;font-size:1.4rem;color：#555;text-align:left;padding:5px 0 10px 10px;display:block'>"
							+ "查看更多评论>>" + "</span>";
					$(this).append(str);
					for (var i = 2; i < len1; i++) {
						$(this).children('.eli').eq(i).addClass('hid').hide();
					}
				    	var tag=0;
						$(this).children('span').bind('click', function() {
							if(tag==0){
							$(this).siblings('.hid').slideDown();
							$(this).text('收起评论').removeClass('moreRe').addClass('sq');
							tag=1;
							}else{
								$(this).siblings('.hid').slideUp();
								$(this).text('查看更多评论').removeClass('sq').addClass('moreRe');
								tag=0;
							};
						});				
					};
				});		
			});
	};
     //获取数据
    Model.prototype.commentDataBeforeRefresh = function(event) {
		var Id = this.getContext().getRequestParameter("Id");
		var type = this.getContext().getRequestParameter("type");
		var commentData = this.comp('commentData');
		var objectRId = Id;
		var objectPId = Id;
		var params = {};	
		if (type == 1) {
			var action = "queryCommentTypeP";
			params = {
				type : type,
				objectPId : objectPId
			};
		} else {
			var action = "queryCommentTypeR";
			params = {
				type : type,
				objectRId : objectRId
			};
		}

		justep.Baas.sendRequest({
			"url" : "/poetry/comment",
			"action" : action,
			"async" : false,
			"params" : params,
			"success" : function(ret) {
				commentData.loadData(ret);
			}
		});
	};

	//获取头像
	Model.prototype.getHeadImg = function(str) {
		return common.headUrl(str);
	};
    //点击二级回复获取焦点
	Model.prototype.focusClick = function(event) {
		var row = event.bindingContext.$object;
		replyId = row.val("commentId");
		objectNickName = row.val("nickName");
		objectUserId = row.val("userId");
		$(this.getElementByXid("input1")).focus();
		this.comp("input1").set({"placeHolder" : "@"+objectNickName});
		level = 2;
		style = 2;
	};
	//点击三级回复获取焦点
	Model.prototype.focus2Click = function(event) {
		var row = event.bindingContext.$object;
		replyId = row.val("replyId");
		objectNickName = row.val("nickName");
		objectUserId = row.val("userId");
		$(this.getElementByXid("input1")).focus();
		this.comp("input1").set({"placeHolder" : "@"+objectNickName});
		level = 3;
		style = 2;
	};
	
	// 判断用户是否登录
	var userId ;
	var nickName;
	Model.prototype.isToken = function() {
		var result = common.isToken();
		if (result.bool) {
			userId = result.userId;
			nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};
	
	//点击发送
	Model.prototype.sendClick = function(event) {
		var self = this;
		if (this.isToken()) {
			// 保存发送内容
	     	var content = this.comp('input1').val();
			if (content== null ||content==""||content==undefined||content.trim().length === 0) {
			    var alertDialog = this.comp("alertDialog");
			    alertDialog.set({message: '请输入内容'});
			    alertDialog.show();
				return null;
			}
			var savecommentData = this.comp("savecommentData");
			var commentData = this.comp("commentData");
			var poetrysData = this.comp("poetrysData");
			var reciteData = this.comp("reciteData");
			var Id = this.getContext().getRequestParameter("Id");
			var type = this.getContext().getRequestParameter("type");
			var objectRId;
			var objectpId;
			var isRead=1;
			if (type == 1) {
				poetrysData.setFilter("filter", "poetryId=" + Id);
				poetrysData.refreshData();
				objectPId = Id;
				objectRId = 0;
				if (objectNickName == null && objectUserId == null) {
					level = 1;
					style = 1;
					objectNickName = poetrysData.val("nickName");
					objectUserId = poetrysData.val("userId");
					poetrysData.setValueByID("commentCount", (poetrysData.val("commentCount")+1),Id);  //评论加一
				}
			} else {
				reciteData.setFilter("filter", "reciteId=" + Id);
				reciteData.refreshData();
				objectRId = Id;
				objectPId = reciteData.val("poetryId");
				if (objectNickName == null && objectUserId == null) {
					level = 1;
					style = 1;
					objectNickName = reciteData.val("reciteNickName");
					objectUserId = reciteData.val("reciteUserId");
					reciteData.setValueByID("commentCount", (reciteData.val("commentCount")+1),Id);  //评论加一
					
				}
			}		  
			if (userId == objectUserId) {isRead=2};
			savecommentData.newData({
				"defaultValues" : [ {
					"userId" : userId, //评论人ID
					"objectRId" : objectRId, //被评论朗诵ID
					"objectPId" : objectPId, //被评论诗歌ID
					"type" : type, //被评论对象类型：1：诗歌 2：朗诵								    
					"content" : content, //评论内容
					"state" : 1, //状态： 1：未删除  2：已删除
					"style" : style, //表现形式：1：评论 2：回复     ?
					"replyId" : replyId, //回复的评论ID ,默认为0      ?				  				    
					"nickName" : nickName, //评论人昵称
					"objectUserId" : objectUserId, //被评论者ID
					"objectNickName" : objectNickName, //被评论者昵称
					"createTime" : new Date(), //评论时间 
					"level" : level,//评论级别：1、2、3级
					"isRead" : isRead,    //1为未读  2 已读
					"status" :1
				}]
			});
			savecommentData.saveData({
				"onSuccess" : function(event) {
					poetrysData.saveData();
					reciteData.saveData();
					commentData.refreshData();
					self.comp('input1').clear();
					self.comp("input1").set({
						"placeHolder" : "说些什么~"
					});
					var pushcontent = "评论了您";
					var pushuserId = objectUserId;
					if (pushuserId == 0||userId == pushuserId) {return null};
					if (type == 1 || type == 2 || type == 3 || type == 6) {
						justep.Baas.sendRequest({
							"method" : "post",
							"url" : "/poetry/pjush",
							"action" : "sendMessage",
							"params" : {
								registrationId : "",
								tag : "",
								alias : pushuserId,
								title : nickName + pushcontent
							}
						});
					}
				}
			});
			
		}
		objectNickName = null;
		objectUserId = null;
	};

	Model.prototype.commentDataAfterRefresh = function(event) {
		this.open();
	};
	Model.prototype.col1Click = function(event){
		common.getHrefCount();
      var row = event.bindingContext.$object;
     justep.Shell.showPage(require.toUrl("./gry.w?userId=" +row.val("userId")));
	};


	Model.prototype.button2Click = function(event){
		this.close();
	};


	Model.prototype.button1Click = function(event){
		this.close();
	};


	Model.prototype.backBtnClick = function(event){
		common.getBackCount();
	};


	return Model;
});