define(function(require) {
	//require("cordova!cordova-plugin-media");
	require("cordova!com.justep.cordova.plugin.qq");
	require("cordova!com.justep.cordova.plugin.weibo");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	var utils = require("$UI/system/components/justep/common/utils");
	var justep = require("$UI/system/lib/justep");
	require('./js/jquery.marquee.min');	
	var common = require("./common");
	var $ = require("jquery");
	require('./audioplayer');

	var Model = function() {
		this.callParent();
		this.userId = 0;
		this.nickName;
		this.mediaRec;
		this.marquee;
		this.playPos;
		this.playState = 0; // 播放状态 0：待播放  1：播放中 2：暂停
		this.netTimer;
		this.play;
		this.firstPlay = true;
	};
	
	// 我来诵读
	Model.prototype.rediteBtnClick = function(event){
		if (this.isToken()) {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl("./lslz.w?poetryId="+this.comp("reciteData").getValue("poetryId")), {userId: this.userId, nickName: this.nickName}); // token验证成功跳转录制页面	
		}
	};
	
	// 订阅
	Model.prototype.subBtnClick = function(event){
		var m = this;
		var self = event.source;
		if (this.isToken()) {
			self.set({"disabled": true});
			var data = this.comp("reciteData");
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId=" + this.userId + " and subUserId=" + data.getValue("reciteUserId"));
			subData.refreshData();
			if (subData.count() == 0) {
				subData.newData({
					"defaultValues" : [ {
						"subUserId" : data.getValue("reciteUserId"),
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				subData.saveData({
					"onSuccess":function(event){
						self.set({"disabled": false});
						data.setValue("subscribeId", 1);
						m.saveMessage(data.getValue("reciteUserId"), data.getValue("poetryTitle"), 3);
					},"onError":function(event) {
						self.set({"disabled": false});
					}
				});
			} else {
				self.set({"disabled": false});
				data.setValue("subscribeId", 1);
			}
			
		}
	};
	
	// 取消订阅
	Model.prototype.sub1BtnClick = function(event){
		if (this.isToken()) {
			var data = this.comp("reciteData");
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId="+this.userId +"and subUserId="+data.getValue("reciteUserId"));
			subData.refreshData({
				"onSuccess": function(event) {
					if (subData.count() > 0) {
						subData.deleteData([ subData.getCurrentRow() ], {
							"onSuccess": function(event) {
								subData.saveData({
									"onSuccess": function(event) {
										data.setValue("subscribeId", 0);
									}
								});
							}
						});
					}
				}
			});
		}
	};
	
	// 收藏
	Model.prototype.scBtnClick = function(event){
		if (this.isToken()) {
			var data = this.comp("reciteData");
			var collectionData = this.comp("collectionData");
			collectionData.clear();
			if (data.getValue("collectId") === 0 || data.getValue("collectId") === undefined) {
				collectionData.newData({
					"defaultValues" : [ {
						"objectId" : data.getCurrentRowID(),
						"type" : 2,
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				collectionData.saveData({
					"onSuccess": function(event){
						data.setValue("collectId", 1);
					}
				});
			} else {
				collectionData.setFilter("filter", "objectId="+data.getCurrentRowID() +" and userId="+this.userId + " and type=2");
				collectionData.refreshData({
					"onSuccess": function(event) {
						if (collectionData.count() > 0) {
							collectionData.deleteData([ collectionData.getCurrentRow() ], {
								"onSuccess": function(event) {
									collectionData.saveData({
										"onSuccess": function(event) {
											data.setValue("collectId", 0);
										}
									});
								}
							});
						}
					}
				});
			}
		} 
	};

	// 点赞
	Model.prototype.zanBtnClick = function(event){
		var m = this;
		if (this.isToken()) {
			var data = this.comp("reciteData");
			var praiseData = this.comp("praiseData");
			praiseData.clear();
			if (data.getValue("praiseId") === 0 || data.getValue("praiseId") === undefined) {
				praiseData.newData({
					"defaultValues" : [ {
						"objectId" : data.getCurrentRowID(),
						"type" : 2,
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				praiseData.saveData({
					"onSuccess": function(event){
						data.setValue("praiseId", 1);
						m.saveMessage(data.getValue("reciteUserId"), data.getValue("poetryTitle"), 1);
					}
				});
			} else {
				praiseData.setFilter("filter", "objectId="+data.getCurrentRowID() +" and userId="+this.userId + " and type=2");
				praiseData.refreshData({
					"onSuccess": function(event) {
						if (praiseData.count() > 0) {
							praiseData.deleteData([ praiseData.getCurrentRow() ], {
								"onSuccess": function(event) {
									praiseData.saveData({
										"onSuccess": function(event) {
											data.setValue("praiseId", 0);
										}
									});
								}
							});
						}
					}
				});
			}
		} 
	};
//	Model.prototype.playAudio = function() {
//		if (media.paused) {
//			this.play();
//			// 定时监听网络制式
//			var net = localStorage.getItem("wifiAlert");
//			if (net == 'on') {
//				this.netTimer = setInterval(function () {
//					if (self.getNetWork() != 'wifi') {
//						self.comp("netTimerDialog").show();
//						self.pause();
//						self.marquee.marquee('pause');
//						$('.audioplayer-playpause a').removeClass('linear linear-bullhorn').addClass('linear linear-arrowrightcircle') ;
//					}
//				}, 1000);
//			}
//		} else {
//			this.pause();
//		}  
//	}
	// 播放
//	Model.prototype.play = function() {
//		this.buffered();
//		media.play();
//		// 显示诗词
//		if ($(".marquee") != null && $(".marquee") != undefined && (this.marquee == null || this.marquee == undefined)) {
//			var reciteTime = this.comp("reciteData").getValue("reciteTime");
//			this.marquee = $(".marquee").bind('finished', function(){
//		        //Change text to something else after first loop finishes
//		        $(this).marquee('destroy');
//			}).marquee({
//			    //speed in milliseconds of the marquee
//			    duration: reciteTime >=2 ? parseInt(reciteTime*400) : 300,
//			    //gap in pixels between the tickers
//			    gap: 50,
//			    //time in milliseconds before the marquee will start animating
//			    delayBeforeStart: 0,
//			    //'left' or 'right'
//			    direction: 'up',
//			    //true or false - should the marquee be duplicated to show an effect of continues flow
//			    duplicated: false
//			});
//		} 
//		if ($(".marquee") != null && $(".marquee") != undefined && this.marquee != null && this.marquee != undefined) {
//			this.marquee.marquee('resume');
//		}
//		$('.audioplayer-playpause').removeClass('linear linear-arrowrightcircle').addClass('linear linear-bullhorn') ;
//	};
//	//暂停
//	Model.prototype.pause = function() {
//		media.pause();
//		if (this.marquee != null && this.marquee != undefined) {
//			this.marquee.marquee('pause');
//		}
//		$('.audioplayer-playpause').removeClass('linear linear-bullhorn').addClass('linear linear-arrowrightcircle') ;
//    };
    //    //播放时间

//    //播放时间
//    Model.prototype.getTime = function() {
//        document.getElementById('media').addEventListener("timeupdate", function () {
//            $('.duration').text(parseInt(media.currentTime)+"''");
//        }, false);
//    };
    //进度条
//     Model.prototype.progress0 = function() {
//        document.getElementById('media').addEventListener("timeupdate", function () {
//        var progress=(media.currentTime/media.duration)*100+'%';
//            $('.play-jd').css('width',progress);
//            if(progress==100+'%'){
//            	$('.play-jd').css('width',0);
//            }
//        }, false);
//    };
	// 播放朗诵
//	Model.prototype.playBtnClick = function(event) {
		
//	this.playAudio();
//	this.getTime();
//	this.progress0();
	
//		var data = this.comp("reciteData");
//		if (this.playState == 0) { // 开始播放
//			this.playState = 1;
//			this.playRecord(data.getValue("reciteTime"), data.getValue("url"), $(event.source.domNode).children());
//			$(event.source.domNode).children().removeClass().addClass('linear linear-bullhorn');
//			
//			// 更新朗诵播放次数
//			data.setValue("listenCount", (data.getValue("listenCount") + 1));
//			data.saveData();
//		} else if (this.playState == 1) { // 暂停
//			this.playState = 2;
//			this.mediaRec.pause();
//			this.marquee.marquee('pause');
//			$(event.source.domNode).children().removeClass().addClass('linear linear-arrowrightcircle');
//			
//		} else if (this.playState == 2) { // 继续
//			this.playState = 1;
//			this.mediaRec.play();
//			this.marquee.marquee('resume');
//			$(event.source.domNode).children().removeClass().addClass('linear linear-bullhorn');
//		}
//	};
	
//	// 录音播放
//	Model.prototype.playRecord = function(reciteTime, url, $play) {
//		this.play = $play;
//		var self = this;
//		this.mediaRec = new Media(self.getUrl(url), function(optio) {
//			this.mediaRec.release();
//			$(".play-jd").width("100%");
//			self.playState = 0;
//			clearInterval(self.netTimer);
//			clearInterval(self.playPos);
//			self.marquee.marquee('destroy');
//			$(".play-jd").width("0px");
//			$play.removeClass().addClass('linear linear-arrowrightcircle');
//		}, function(err) {
//			//alert(JSON.stringify(err));
//		});
//		this.mediaRec.play();
//		
//		// 显示诗词
//		if ($(".marquee") != null && $(".marquee") != undefined) {
//			this.marquee = $(".marquee").bind('finished', function(){
//		        //Change text to something else after first loop finishes
//		        $(this).marquee('destroy');
//			}).marquee({
//			    //speed in milliseconds of the marquee
//			    duration: reciteTime >=2 ? parseInt(reciteTime*400) : 300,
//			    //gap in pixels between the tickers
//			    gap: 50,
//			    //time in milliseconds before the marquee will start animating
//			    delayBeforeStart: 0,
//			    //'left' or 'right'
//			    direction: 'up',
//			    //true or false - should the marquee be duplicated to show an effect of continues flow
//			    duplicated: false
//			});
//		}
//		
//		// 计算播放进度
//		this.playPos = setInterval(function () {
//			// get media position
//			self.mediaRec.getCurrentPosition(
//		        // success callback
//		        function (position) {
//		            if (position > 0) {
//		            	$play.parents(".play").find(".playCon").find(".play-jd").width(((position/reciteTime)*100) + "%");
//		            }
//		        },
//		        // error callback
//		        function (e) {
//		        	//alert("Error getting pos=" + e);
//		        }
//		    );
//		}, 100);
//		
//		// 定时监听网络制式
//		var net = localStorage.getItem("wifiAlert");
//		if (net == 'on') {
//			this.netTimer = setInterval(function () {
//				if (self.getNetWork() != 'wifi') {
//					self.comp("netTimerDialog").show();
//					clearInterval(self.netTimer);// 清空计时器
//					self.playState = 2;
//					self.mediaRec.pause();
//					self.marquee.marquee('pause');
//					$play.removeClass().addClass('linear linear-arrowrightcircle');
//				}
//			}, 1000);
//		}
//	};
	
	Model.prototype.netTimerDialogOK = function(event){
//		this.playState = 1;
//		this.mediaRec.play();
//		this.play();
		$('audio').get(0).play();
		if ($('.marquee') != null && $('.marquee') != undefined) {
			$('.marquee').marquee('resume');
		}
		$(".audioplayer-playpause").attr( 'title', "Pause").find( 'a' ).html("Pause");
		$(".audioplayer").addClass("audioplayer-playing").removeClass("audioplayer-stopped");
	};
    
	Model.prototype.netTimerDialogCancel = function(event){
//		this.playState = 0;
//		clearInterval(this.playPos);
//		this.mediaRec.stop();
//		this.pause();
		this.closeMedia();
//		this.play.removeClass().addClass('linear linear-arrowrightcircle');
	};

	// 跳转评论页面
	Model.prototype.plBtnClick = function(event) {
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./plList.w?Id=" + this.comp("reciteData").getCurrentRowID() + "&type=2"));
	};

	// 查询当前朗诵
	Model.prototype.reciteDataBeforeRefresh = function(event){
		var data = event.source;
		if (this.getContext().getRequestParameter("userId") != undefined && this.getContext().getRequestParameter("userId") != null) {
			this.userId = this.getContext().getRequestParameter("userId");
		}
		data.clear();
		data.filters.setVar("userId", this.userId);
		data.filters.setVar("reciteId", this.getContext().getRequestParameter("reciteId"));
	};
	
	// 判断token
	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};
	
	// 保存消息
	Model.prototype.saveMessage = function(userId, title, type) {
		if (userId != 0 && userId != this.userId){ // 判断当前用户是否为诗歌发布者
			var self = this;
			var messageData = this.comp("messageData");
			messageData.clear();
			var typeVal = type == 1 ? '赞' : type == 2 ? '评论' : type == 3 ? '订阅' : type == 4 ? '分享' : type == 5 ? '系统' : '朗诵';
			var messageContent = "";
			if (type == 3) {
				messageContent = typeVal + "了您";
			} else {
				messageContent = typeVal + "了您的诗歌" + title;
			}
			messageData.newData({
				"defaultValues" : [ {
					"userId" : userId,
					"content" : messageContent,
					"state" : 1,
					"createTime" : new Date(),
					"type" : type,
					"pushUserId" : self.userId,
					"pushNickName" : self.nickName,
					"isRead" : 1
				} ]
			});
			messageData.saveData({
				"onSuccess" : function(event) {
					if (type == 1 || type == 2 || type == 3 || type == 6) {
						justep.Baas.sendRequest({
							"method" : "post",
							"url" : "/poetry/pjush",
							"action" : "sendMessage",
							"params" : {
								registrationId : "",
								tag : "",
								alias : userId,
								title : self.nickName + messageContent
							}
						});
					}
				}
			});
		}
	};

	// 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	if (str != undefined) {
    		return common.textToBr(str);
    	} else {
    		return "";
    	}
    };
    
    // 获取头像
    Model.prototype.getHeadImg = function(str) {
    	return common.headUrl(str);
    };
    
	// 获取又拍云全路径
    Model.prototype.getUrl = function(str) {
    	return common.imgUrl(str, "ph400");
    };
    
    // 日期转换
	Model.prototype.toDateFormat = function(str) {
    	if (str != undefined && str != null && str != "") {
    		var array = str.toString().split(" ");
    		var arr1 = array[0].toString().split("-");
    		var str1 = arr1[1] + "." + arr1[2];
    		var arr2 = array[1].toString().split(":");
    		var str2 = arr2[0] + ":" + arr2[1];
    		str = str1 + " " + str2;
    	}
    	return str;
    };
    
    //设置朗诵时长时间格式
    Model.prototype.setTimeFormat = function(time) {
    	return common.durationToFormat(time);
    };
    
    // 分享
	Model.prototype.shareClick = function(event){
		this.comp('popOver1').show();
		this.isToken();
	};
    
    // 微信分享
	Model.prototype.wxBtnClick = function(event){
		var self = this;
		var data = self.comp("reciteData");
		function success(result) {
			self.saveRecite();
			self.saveMessage(data.getValue("reciteUserId"), data.getValue("poetryTitle"), 4);
		}
		function error(result) {
			if (result != '用户点击取消并返回') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		navigator.weixin.share({
			message : {
				title : data.getValue("poetryTitle"),
				description : "朗诵者：" + data.getValue("reciteNickName"),
				mediaTagName : "Media Tag Name(optional)",
				thumb : common.imgUrl(data.getValue("backgroundImg"), "pt50"),
				media : {
					 type: navigator.weixin.Type.WEBPAGE, // webpage
					 webpageUrl : common.shareReciteUrl + data.getCurrentRowID()
				// webpage
				}
			},
			scene : navigator.weixin.Scene.SESSION
		}, success, error);
		self.comp("popOver1").hide();
	};
    
    // 朋友圈分享
	Model.prototype.pyqBtnClick = function(event){
		var self = this;
		var data = self.comp("reciteData");
		function success(result) {
			self.saveRecite();
			self.saveMessage(data.getValue("reciteUserId"), data.getValue("poetryTitle"), 4);
		}
		function error(result) {
			if (result != '用户点击取消并返回') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		navigator.weixin.share({
			message : {
				title : data.getValue("poetryTitle"),
				description : "朗诵者：" + data.getValue("reciteNickName"),
				mediaTagName : "Media Tag Name(optional)",
				thumb : common.imgUrl(data.getValue("backgroundImg"), "pt50"),
				media : {
					 type: navigator.weixin.Type.WEBPAGE, // webpage
					 webpageUrl : common.shareReciteUrl + data.getCurrentRowID()
				// webpage
				}
			},
			scene : navigator.weixin.Scene.TIMELINE
		}, success, error);
		self.comp("popOver1").hide();
	};
    
    // 微博分享
	Model.prototype.wbBtnClick = function(event){
		var self = this;
		var data = self.comp("reciteData");
		function success(result) {
			self.saveRecite();
			self.saveMessage(data.getValue("reciteUserId"), data.getValue("poetryTitle"), 4);
		}
		function error(result) {
			self.comp("alertDialog").show({message: '分享失败'});
		}
		var args = {};
		//这里是新插件的写法 分享图片+网页
		args.url = common.shareReciteUrl + data.getCurrentRowID();
		args.defaultText = "";
		args.media = {
			type : "image",
			title : data.getValue("poetryTitle"),
			description : "朗诵者：" + data.getValue("reciteNickName"),
			url : common.imgUrl(data.getValue("backgroundImg"), "pt50")
		};
		navigator.Weibo.shareToWeibo(success, error, args);
		self.comp("popOver1").hide();
	};
    
    // qq分享
	Model.prototype.qqBtnClick = function(event){
		var self = this;
		var data = self.comp("reciteData");
		function success(result) {
			self.saveRecite();
			self.saveMessage(data.getValue("reciteUserId"), data.getValue("poetryTitle"), 4);
		}
		function error(result) {
			if (result != 'cancelled by user') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		var args = {};
		args.url = utils.getShareUrl(common.shareReciteUrl + data.getCurrentRowID());
		args.title =  data.getValue("poetryTitle");
		args.description = "朗诵者：" + data.getValue("reciteNickName");
		args.imageUrl = common.imgUrl(data.getValue("backgroundImg"), "pt50");
		args.appName = "share";	
		navigator.QQ.shareToQQ(success, error, args);
		self.comp("popOver1").hide();
	};
    
    // 当前朗诵分享次数加一
    Model.prototype.saveRecite = function() {
    	var data = this.comp("reciteData");
		data.setValue("retransmissionCount", data.getValue("retransmissionCount") + 1);
		data.saveData();
    };
    
    // 获取网络
	Model.prototype.getNetWork = function() {
		return common.getNetWork();
	};
	
	// 是否显示订阅
	Model.prototype.isDy = function(uid, subId) {
		return (subId == undefined || subId == 0) && uid != this.getContext().getRequestParameter("userId");
	};
	Model.prototype.isYdy = function(uid, subId) {
		return subId > 0 && uid != this.getContext().getRequestParameter("userId");
	};
    
    // 跳转个人展示
	Model.prototype.a1Click = function(event){
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + this.comp("reciteData").getValue("reciteUserId")));
	};
	Model.prototype.image1Click = function(event){
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + this.comp("reciteData").getValue("reciteUserId")));
	};
	
	Model.prototype.closeMedia = function() { 
//		if (this.mediaRec != undefined || this.mediaRec != null) {
//			this.mediaRec.stop();
//			this.mediaRec.release();
//		}
//		this.playState = 0;
//		clearInterval(this.netTimer);
//		clearInterval(this.playPos);
//		this.pause();
		$("audio").get(0).pause();
		$("audio").stop(true, true);
		if ($('.marquee') != undefined && $('.marquee') != null) {
			$('.marquee').marquee('destroy');
		}
		$(".audioplayer-bar-played").width(0 * 100 + '%' );
		$(".audioplayer").removeClass("audioplayer-playing").addClass("audioplayer-stopped");
//		if (this.play != undefined || this.play != null) {
//			this.play.removeClass().addClass('linear linear-arrowrightcircle');
//		}
	};
    
    // 页面离开时
	Model.prototype.modelInactive = function(event){
		this.closeMedia();
	};

    // 跳转朗诵列表页面
	Model.prototype.col13Click = function(event){
		common.getHrefCount();
		var data = this.comp("reciteData");
		justep.Shell.showPage(require.toUrl('./sglsList.w?poetryId=' + data.getValue("poetryId") + '&userId=' + this.userId + '&title='+data.getValue("poetryTitle")));
	};

    
//	Model.prototype.modelActive = function(event){
//		this.comp("reciteData").refreshData();
//	};

	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		justep.Shell.setIsSinglePage(true);
		this.comp("popOver3").hide();
		this.comp("panel2").removeClass("hide");
		var self = this;
		//var reciteTime = this.comp("reciteData").getValue("reciteTime");  
		$( '#media' ).audioPlayer();
		$(".audioplayer-playpause").find("a").click(function(){
			var text = $(this).text();
			if (text == 'Play') {
				if (self.firstPlay) {
					var data = self.comp("reciteData");
					data.setValue("listenCount", (data.getValue("listenCount") + 1));
					data.saveData();
					
					var net = localStorage.getItem("wifiAlert");
					if (net == 'on') {
						self.isTitle = false;
						self.netTimer = setInterval(function () {
							if (self.getNetWork() == '2g' || self.getNetWork() == '3g' || self.getNetWork() == '4g' || self.getNetWork() == 'cellular') {
								self.comp("netTimerDialog").show();
								clearInterval(self.netTimer);
								$("audio").get(0).pause();
								$(".marquee").marquee('pause');
							}
						}, 1000);
					}
					self.firstPlay = false;
				}
			}
		});
//		$("audio").get(0).addEventListener( 'ended', function()
//		{ // 播放结束
//			self.firstPlay = true;
////			$(".audioplayer-playpause").attr("title", 'Play');
////			$(".audioplayer-playpause").find("a").text('Play');
//		});
	};

    
	Model.prototype.button1Click = function(event){
		common.getBackCount();
	};


    
	return Model;
});