define(function(require){
	var $ = require("jquery");
	require("cordova!cordova-plugin-media");
	require("cordova!com.justep.cordova.plugin.qq");
	require("cordova!com.justep.cordova.plugin.weibo");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	var utils = require("$UI/system/components/justep/common/utils");
	var justep = require("$UI/system/lib/justep");
//	require("./js/jquery.lazyload.min");
//	var loading = require("./loadding");
	require('./js/jquery.marquee.min');	
	var common = require("./common");

	var Model = function(){
		this.callParent();
		this.poetryId;
		this.userId;
		this.nickName;
//		this.mediaRec = null;
//		this.marquee = null;
//		this.playPos;
//		this.playState = 0; // 播放状态 0：播放中  1：暂停 2：播放完成
//		this.netTime;
//		this.play;
//		this.row;
//		this.row1;
//		this.sroll1 = true;
//		this.timeout;
//		this.isLeave = false; // 是否离开页面
//		this.isClick = false; // 判断是否点击播放还是自动播放完成
		this.errCount = 0;
	};
	
	Model.prototype.modelLoad = function(event){
		this.comp('sglsList').setHeight("top", 58);
		$(".loadingDiv").addClass("hide");
		$(".lslist").removeClass("hide");
		
//		this.lazyLoad();
	};
	
	
//	Model.prototype.lazyLoad = function() {
//		$("li.lazy").lazyload({
//			effect : "show",
//			container: $(".ulBox"),
//			failurelimit : 2,
//			load : function(e) {
//				$(this).removeClass("lazy");
//			}
//		});
//	};
		
	//设置显示的时间格式
    Model.prototype.setTimeFormat = function(time) {
    	return common.durationToFormat(time);
    };
    
    // 获取头像
    Model.prototype.getHeadImg = function(str) {
    	return common.headUrl(str);
    };
    
	// 获取又拍云全路径
    Model.prototype.getImg = function(str) {
    	return common.imgUrl(str, "ph400");
    };
	
	// 接收参数
	Model.prototype.modelParamsReceive = function(event){
		this.poetryId = this.getContext().getRequestParameter("poetryId");
		this.comp("titleBar").set({title:this.getContext().getRequestParameter("title")});
	};

	// 刷新前添加过滤条件
	Model.prototype.reciteDataBeforeRefresh = function(event){
		var data = event.source;
		data.filters.setVar("poetryId", this.getContext().getRequestParameter("poetryId"));
		data.filters.setVar("userId", this.getContext().getRequestParameter("userId"));
	};
	
	// 我来诵读
	Model.prototype.rediteBtnClick = function(event){
		if (this.isToken()) {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl("./lslz.w?poetryId="+this.poetryId), {userId: this.userId, nickName: this.nickName}); // token验证成功跳转录制页面	
		}
	};
	
	// 订阅
	Model.prototype.subBtnClick = function(event){
		var self = event.source;
		var m = this;
		if (this.isToken()) {
			self.set({"disabled": true});
			var row = event.bindingContext.$object; // 获取当前行对象
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId=" + this.userId + " and subUserId=" + row.val("reciteUserId"));
			subData.refreshData();
			if (subData.count() == 0) {
				subData.newData({
					"defaultValues" : [ {
						"subUserId" : row.val("reciteUserId"),
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				subData.saveData({
					"onSuccess":function(event){
						self.set({"disabled": false});
						m.comp("reciteData").setValue("subscribeId", 1, row);
						m.saveMessage(row.val("reciteUserId"), row.val("poetryTitle"), 3);
					},"onError":function(event) {
						self.set({"disabled": false});
					}
				});
			} else {
				self.set({"disabled": false});
				m.comp("reciteData").setValue("subscribeId", 1, row);
			}
		}
	};
	
	// 取消订阅
	Model.prototype.sub1BtnClick = function(event){
		var m = this;
		if (this.isToken()) {
			var row = event.bindingContext.$object; // 获取当前行对象
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId="+this.userId +"and subUserId="+row.val("reciteUserId"));
			subData.refreshData({
				"onSuccess": function(event) {
					if (subData.count() > 0) {
						subData.deleteData([ subData.getCurrentRow() ], {
							"onSuccess": function(event) {
								subData.saveData({
									"onSuccess": function(event) {
										m.comp("reciteData").setValue("subscribeId", 0, row);
									}
								});
							}
						});
					}
				}
			});
		}
	};
	
	// 收藏
	Model.prototype.scBtnClick = function(event){
		var m = this;
		if (this.isToken()) {
			var row = event.bindingContext.$object; // 获取当前行对象

			var collectionData = this.comp("collectionData");
			collectionData.clear();
			if (row.val("collectId") === 0 || row.val("collectId") === undefined) {
				collectionData.newData({
					"defaultValues" : [ {
						"objectId" : row.getID(),
						"type" : 2,
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				collectionData.saveData({
					"onSuccess": function(event){
						m.comp("reciteData").setValue("collectId", 1, row);
					}
				});
			} else {
				collectionData.setFilter("filter", "objectId="+row.getID() +" and userId="+this.userId + " and type=2");
				collectionData.refreshData({
					"onSuccess": function(event) {
						if (collectionData.count() > 0) {
							collectionData.deleteData([ collectionData.getCurrentRow() ], {
								"onSuccess": function(event) {
									collectionData.saveData({
										"onSuccess": function(event) {
											m.comp("reciteData").setValue("collectId", 0, row);
										}
									});
								}
							});
						}
					}
				});
			}
		} 
	};
	
	// 跳转评论页面
	Model.prototype.commentBtnClick = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./plList.w?Id=" + row.getID() + "&type=2"));
	};	
		
	// 点赞
	Model.prototype.zanBtnClick = function(event){
		var m = this;
		if (this.isToken()) {
			var row = event.bindingContext.$object; // 获取当前行对象
			var praiseData = this.comp("praiseData");
			praiseData.clear();
			if (row.val("praiseId") === 0 || row.val("praiseId") === undefined) {
				praiseData.newData({
					"defaultValues" : [ {
						"objectId" : row.getID(),
						"type" : 2,
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				praiseData.saveData({
					"onSuccess": function(event){
						m.comp("reciteData").setValue("praiseId", 1, row);
						m.saveMessage(row.val("reciteUserId"), row.val("poetryTitle"), 1);
					}
				});
			} else {
				praiseData.setFilter("filter", "objectId="+row.getID() +" and userId="+this.userId + " and type=2");
				praiseData.refreshData({
					"onSuccess": function(event) {
						if (praiseData.count() > 0) {
							praiseData.deleteData([ praiseData.getCurrentRow() ], {
								"onSuccess": function(event) {
									praiseData.saveData({
										"onSuccess": function(event) {
											m.comp("reciteData").setValue("praiseId", 0, row);
										}
									});
								}
							});
						}
					}
				});
			}
		} 
	};
	
//	Model.prototype.closeMedia = function(style) {
//		var ss = false;
//		if (this.timeout != undefined && this.timeout != null) {
//			clearTimeout(this.timeout);
//		}
//		if (this.mediaRec != undefined && this.mediaRec != null) {
//			this.mediaRec.stop();
//		}
//		if (style != 1) {
//			$(".bfBtn").attr("disabled", false);
//			loading.unload();
//		}
//		this.playState = 0;
//		clearInterval(this.netTimer);
//		clearInterval(this.playPos);
//		if (this.marquee != undefined && this.marquee != null) {
//			this.marquee.marquee('destroy');
//			this.marquee = null;
//		}
//		ss = true;
//		return ss;
//	};
	
	// 播放录音
//	Model.prototype.bfBtnClick = function(event){
//		$(".bfBtn").attr("disabled", true);
//		this.isClick = true;
//		$(event.source.domNode).parent('.play').css('visibility', 'hidden');
//		$(event.source.domNode).parents(".paly-area").append(loading.loadStr());
//		if (this.play != undefined && this.play != null) {
//			this.play.parents(".paly-area").find(".loading").remove();
//			this.play.css('visibility', 'visible');
//			this.play.siblings('.gdCon,.playBf').addClass('hide');
//			this.play.parents(".paly-area").find(".playBf").find(".play-jd").width("0px");
//			this.play = null;
//		}
//		this.row1 = event.bindingContext.$object; // 获取行对象
//		this.play = $(event.source.domNode).parent('.play');
//		if (this.mediaRec != null && this.mediaRec != undefined) {
//			this.mediaRec.stop();
//		} else {
//			this.isClick = false;
//			this.playRecord();
//		}
//	};
//	
//	// 录音播放
//	Model.prototype.playRecord = function() {
//		var self = this;
//		var row = this.row1;
//    	var $play = this.play;
//    	var reciteTime = row.val("reciteTime");
//		this.mediaRec = new Media(self.getImg(row.val("url")), function(optio) {
//			self.mediaRec = null;
//			if (!self.isLeave && self.isClick) {
//				self.isClick = false;
//				var ss = self.closeMedia(1);
//				if (ss) {
////					self.timeout = setTimeout(function() {
//						self.playRecord();
////					},2000);
//				}
//			} else {
//				if (self.play != undefined && self.play != null) {
//					self.play.parents(".paly-area").find(".loading").remove();
//					self.play.css('visibility', 'visible');
//					self.play.siblings('.gdCon,.playBf').addClass('hide');
//					self.play.parents(".paly-area").find(".playBf").find(".play-jd").width("0px");
//					self.play = null;
//				}
//				self.closeMedia(2);
//			}
//		}, function(err) {
//
//			self.errCount = self.errCount + 1;
//			if (self.errCount > 2) {
//				self.mediaRec = null;
//				if (self.play != undefined && self.play != null) {
//					self.play.parents(".paly-area").find(".loading").remove();
//					self.play.css('visibility', 'visible');
//					self.play.siblings('.gdCon,.playBf').addClass('hide');
//					self.play.parents(".paly-area").find(".playBf").find(".play-jd").width("0px");
//					self.play = null;
//				}
//				return;
//			}
//			self.closeMedia(2);
//			if (err.code == 1) {
//				self.comp("alertDialog").show({message:'播放失败'});
//			} else if (err.code == 2) {
//				self.comp("alertDialog").show({message:'网络错误'});
//			} else if (err.code == 3) {
//				self.comp("alertDialog").show({message:'解码失败'});
//			} else if (err.code == 4) {
//				self.comp("alertDialog").show({message:'音频格式不支持'});
//			}
//		}, function(status){
//			if (status == 1) { //初始
//			
//			} else if (status == 2) { //开始播放
//				loading.unload();
//        		$play.siblings('.gdCon,.playBf').removeClass('hide');
//
//        		// 显示诗词
//				self.marquee = $play.parents(".paly-area").find(".marquee").bind('finished', function(){
//			        //Change text to something else after first loop finishes
//			        $(this).marquee('destroy');
//			        self.marquee = null;
//				}).marquee({
//				    //speed in milliseconds of the marquee
//				    duration: reciteTime >=2 ? parseInt(reciteTime*500) : 300,
//				    //gap in pixels between the tickers
//				    gap: 50,
//				    //time in milliseconds before the marquee will start animating
//				    delayBeforeStart: 0,
//				    //'left' or 'right'
//				    direction: 'up',
//				    //true or false - should the marquee be duplicated to show an effect of continues flow
//				    duplicated: false
//				});
//				
//				var data = self.comp("reciteData");
//				data.setValue("listenCount", (data.getValue("listenCount", row) + 1), row);
//				data.saveData();
//				
//				// 计算播放进度
//				self.playPos = setInterval(function () {
//					// get media position
//					self.mediaRec.getCurrentPosition(
//				        // success callback
//				        function (position) {
//				            if (position > 0) {
//				            	$play.parents(".paly-area").find(".playBf").find(".play-jd").width(((position/reciteTime)*100) + "%");
//				            }
//				        },
//				        // error callback
//				        function (e) {
//				        	//alert("Error getting pos=" + e);
//				        }
//				    );
//				}, 200);
//				
//				// 定时监听网络制式
//				var net = localStorage.getItem("wifiAlert");
//				if (net == 'on') {
//					self.netTimer = setInterval(function () {
//						if (self.getNetWork() == '2g' || self.getNetWork() == '3g' || self.getNetWork() == '4g' || self.getNetWork() == 'cellular') {
//							self.comp("netTimerDialog").show();
//							clearInterval(self.netTimer);
//							self.playState = 1;
//							if (self.mediaRec != undefined && self.mediaRec != null) {
//								self.mediaRec.pause();
//							}
//							if (self.marquee != undefined && self.marquee != null) {
//								self.marquee.marquee('pause');
//							}
//							$play.parents(".paly-area").find(".playBtn").children().removeClass().addClass('linear linear-arrowrightcircle');
//						}
//					}, 1000);
//				} 
//				
//			} else if (status == 3) { // 暂停
//				
//			} else if (status == 4) { // 停止
//				self.mediaRec = null;
//				self.errCount = 0;
//			}
//		});
//		this.mediaRec.play();
//		
//		setTimeout(function(){
//			$(".bfBtn").attr("disabled", false);
//		}, 2000);
//		
//		
//	};
//		
//	Model.prototype.netTimerDialogOK = function(event){
//		this.playState = 0;
//		if (this.mediaRec != null && this.mediaRec) {
//			this.mediaRec.play();
//		}
//		if (this.marquee != undefined && this.marquee != null) {
//			this.marquee.marquee('resume');
//		}
//		this.play.parents(".paly-area").find(".playBtn").children().removeClass().addClass('linear linear-bullhorn');
//	};
//	
//	Model.prototype.netTimerDialogCancel = function(event){
//		if (this.play != undefined && this.play != null) {
//			this.play.parents(".paly-area").find(".loading").remove();
//			this.play.css('visibility', 'visible');
//			this.play.siblings('.gdCon,.playBf').addClass('hide');
//			this.play.parents(".paly-area").find(".playBf").find(".play-jd").width("0px");
//			this.play = null;
//		}
//		this.closeMedia(2);
//	};
	
	// 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	return common.textToBr(str);
    };
	
	// 日期转换
	Model.prototype.toDateFormat = function(str) {
    	if (str != undefined && str != null && str != "") {
    		var array = str.toString().split(" ");
    		var arr1 = array[0].toString().split("-");
    		var str1 = arr1[1] + "." + arr1[2];
    		var arr2 = array[1].toString().split(":");
    		var str2 = arr2[0] + ":" + arr2[1];
    		str = str1 + " " + str2;
    	}
    	return str;
    };
	
	// 判断token
	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};
	
	// 保存消息
	Model.prototype.saveMessage = function(userId, title, type) {
		if (this.userId != null && this.userId != undefined && this.userId != "" && userId != 0 && userId != this.userId) { // 判断当前用户是否为诗歌发布者
			var self = this;
			var messageData = this.comp("messageData");
			messageData.clear();
			var typeVal = type == 1 ? '赞' : type == 2 ? '评论' : type == 3 ? '订阅' : type == 4 ? '分享' : type == 5 ? '系统' : '朗诵';
			var messageContent = "";
			if (type == 3) {
				messageContent = typeVal + "了您";
			} else {
				messageContent = typeVal + "了您的诗歌" + title;
			}
			messageData.newData({
				"defaultValues" : [ {
					"userId" : userId,
					"content" : messageContent,
					"state" : 1,
					"createTime" : new Date(),
					"type" : type,
					"pushUserId" : self.userId,
					"pushNickName" : self.nickName,
					"isRead" : 1
				} ]
			});
			messageData.saveData({
				"onSuccess" : function(event) {
					if (type == 1 || type == 2 || type == 3 || type == 6) {
						justep.Baas.sendRequest({
							"method" : "post",
							"url" : "/poetry/pjush",
							"action" : "sendMessage",
							"params" : {
								registrationId : "",
								tag : "",
								alias : userId,
								title : self.nickName + messageContent
							}
						});
					}
				}
			});
		}
	};	
	
	// 继续、暂停播放
//	Model.prototype.playBtnClick = function(event){
//		if (this.playState == 0) {
//			this.playState = 1;
//			if (this.mediaRec != undefined && this.mediaRec != null) {
//				this.mediaRec.pause();
//			}
//			if (this.marquee != undefined && this.marquee != null) {
//				this.marquee.marquee('pause');
//			}
//			$(event.source.domNode).children().removeClass().addClass('linear linear-arrowrightcircle');
//		} else {
//			this.playState = 0;
//			if (this.mediaRec != undefined && this.mediaRec != null) {
//				this.mediaRec.play();
//			}
//			if (this.marquee != undefined && this.marquee != null) {
//				this.marquee.marquee('resume');
//			}
//			$(event.source.domNode).children().removeClass().addClass('linear linear-bullhorn');
//		}
//	};	
	
	Model.prototype.modelActive = function(event){
//		this.comp("reciteData").refreshData();
//		this.lazyLoad();
		this.poetryId = this.getContext().getRequestParameter("poetryId");
		this.comp("titleBar").set({title:this.getContext().getRequestParameter("title")});
	};	
	
	// 分享
	Model.prototype.shareClick = function(event){
		this.row = event.bindingContext.$object; // 获取当前行对象
		this.comp('popOver1').show();
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		}
	};
	
	// 微信分享
	Model.prototype.wxBtnClick = function(event){
		var self = this;
		var row = this.row; // 获取当前行对象
		function success(result) {
			self.saveRecite(row);
			self.saveMessage(self.row.val("reciteUserId"), row.val("poetryTitle"), 4);
		}
		function error(result) {
			if (result != '用户点击取消并返回') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		navigator.weixin.share({
			message : {
				title : row.val("poetryTitle"),
				description : "朗诵者：" + row.val("reciteNickName"),
				mediaTagName : "Media Tag Name(optional)",
				thumb : common.imgUrl(row.val("backgroundImg"), "pt50"),
				media : {
					 type: navigator.weixin.Type.WEBPAGE, // webpage
					 webpageUrl : common.shareReciteUrl + row.getID()
				// webpage
				}
			},
			scene : navigator.weixin.Scene.SESSION
		}, success, error);
		self.comp("popOver1").hide();
	};
    
    // 朋友圈分享
	Model.prototype.pyqBtnClick = function(event){
		var self = this;
		var row = this.row; // 获取当前行对象
		function success(result) {
			self.saveRecite(row);
			self.saveMessage(row.val("reciteUserId"), row.val("poetryTitle"), 4);
		}
		function error(result) {
			if (result != '用户点击取消并返回') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		navigator.weixin.share({
			message : {
				title : row.val("poetryTitle"),
				description : "朗诵者：" + row.val("reciteNickName"),
				mediaTagName : "Media Tag Name(optional)",
				thumb : common.imgUrl(row.val("backgroundImg"), "pt50"),
				media : {
					 type: navigator.weixin.Type.WEBPAGE, // webpage
					 webpageUrl : common.shareReciteUrl + row.getID()
				// webpage
				}
			},
			scene : navigator.weixin.Scene.TIMELINE
		}, success, error);
		self.comp("popOver1").hide();
	};
    
    // 微博分享
	Model.prototype.wbBtnClick = function(event){
		var self = this;
		var row = this.row; // 获取当前行对象
		function success(result) {
			self.saveRecite(row);
			self.saveMessage(row.val("reciteUserId"), row.val("poetryTitle"), 4);
		}
		function error(result) {
			self.comp("alertDialog").show({message: '分享失败'});
		}
		var args = {};
		//这里是新插件的写法 分享图片+网页
		args.url = common.shareReciteUrl + row.getID();
		args.defaultText = "";
		args.media = {
			type : "image",
			title : row.val("poetryTitle"),
			description : "朗诵者：" + row.val("reciteNickName"),
			url : common.imgUrl(row.val("backgroundImg"), "pt50")
		};
		navigator.Weibo.shareToWeibo(success, error, args);
		self.comp("popOver1").hide();
	};
    
    // qq分享
	Model.prototype.qqBtnClick = function(event){
		var self = this;
		var row = this.row; // 获取当前行对象
		function success(result) {
			self.saveRecite(row);
			self.saveMessage(row.val("reciteUserId"), row.val("poetryTitle"), 4);
		}
		function error(result) {
			if (result != 'cancelled by user') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		var args = {};
		args.url = utils.getShareUrl(common.shareReciteUrl + row.getID());
		args.title =  row.val("poetryTitle");
		args.description = "朗诵者：" + row.val("reciteNickName");
		args.imageUrl = common.imgUrl(row.val("backgroundImg"), "pt50");
		args.appName = "share";	
		navigator.QQ.shareToQQ(success, error, args);
		self.comp("popOver1").hide();
	};
    
    // 当前朗诵分享次数加一
//    Model.prototype.saveRecite = function(row) {
//    	var data = this.comp("reciteData");
//		data.setValue("retransmissionCount", (row.val("retransmissionCount") + 1), row);
//		data.saveData();
//    };	
	
	// 获取网络
//	Model.prototype.getNetWork = function() {
//		return common.getNetWork();
//	};

	// 跳转个人展示页
	Model.prototype.span3Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("reciteUserId")));
	};
	Model.prototype.image1Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("reciteUserId")));
	};

	// 是否显示订阅
	Model.prototype.isDy = function(uid, subId) {
		return (subId == undefined || subId == 0) && uid != this.getContext().getRequestParameter("userId");
	};
	Model.prototype.isYdy = function(uid, subId) {
		return subId > 0 && uid != this.getContext().getRequestParameter("userId");
	};
	// 跳转详情页
	Model.prototype.row4Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./sdDetail.w?reciteId="+row.getID()+"&userId="+this.getContext().getRequestParameter("userId")));
	};
	
	// 离开网页
//	Model.prototype.modelInactive = function(event){
//		this.isLeave = true;
//		if (this.mediaRec != null && this.mediaRec != undefined) {
//			this.mediaRec.stop();
//		}
//	};
	
	Model.prototype.title1Click = function(event){
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./ycsgDetail.w?poetryId="+this.poetryId+"&userId="+this.getContext().getRequestParameter("userId")));
	};
	
//	Model.prototype.scrollView1PullDown = function(event){
//		var self = this;
//		setTimeout(function(){
//			self.lazyLoad();
//		}, 500);
//		this.closeMedia();
//	};
//	
//	Model.prototype.scrollView1PullUp = function(event){
//		var self = this;
//		if (this.sroll1) {
//			setTimeout(function(){
//				self.lazyLoad();
//			}, 500);
//		}
//	};
//	
//	Model.prototype.scrollView1ScrollEnd = function(event){
//		var ss = $(".lslist").find(".x-pull-up-label").text();
//		if (ss == "已经到最后.") {
//			this.sroll1 = false;
//		}
//	};
	
	Model.prototype.paly_areaClick = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./sdDetail.w?reciteId="+row.getID()+"&userId="+this.getContext().getRequestParameter("userId")));
	};
	
	Model.prototype.backBtnClick = function(event){
		common.getBackCount();
	};
	
	return Model;
});