define(function(require){
	require("cordova!at.modalog.cordova.plugin.cache");
	require("cordova!cordova-plugin-app-version");
	var justep = require("$UI/system/lib/justep");
	var versionChecker = require("./appVersionChecker");
	var $ = require("jquery");
	var common = require("./common");

	var Model = function(){
		this.callParent();
	};
	
	
	// 初始数据
	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		var alert = this.comp("wifiAlert");
		var wifi = localStorage.getItem("wifiAlert");
		if (wifi === "on") {
			alert.set({checked:true});
		} else {
			alert.set({checked:false});
		}
		document.addEventListener('deviceready', function() {
			cordova.getAppVersion.getVersionNumber(function(currentVersion) {
				 $(".version").text("V" + currentVersion);
			}, function() {
				
			});
		});
	};
	
	Model.prototype.isAndroid = function() {
		if (device.platform == "Android") {
			return true;
		} else {
			return false;
		}
	}

	// 设置WIFI提醒
	Model.prototype.wifiAlertChange = function(event){
		localStorage.setItem("wifiAlert", event.source.val());
	};

	// 清除缓存
	Model.prototype.clearCacheClick = function(event){
		var self = this;
		document.addEventListener('deviceready', onDeviceReady);
		function onDeviceReady() {
			var success = function(status) {
				self.comp("alertDialog").show({message: '清除缓存成功'});
			};

			var error = function(status) {
				self.comp("alertDialog").show({message: '清除缓存失败'});
			};
			window.cache.clear(success, error);
		}
	};

	// 版本更新
	Model.prototype.visionUpdateClick = function(event){
		document.addEventListener("deviceready", function() {
			versionChecker.check();
		});
	};

	// 跳转反馈意见表
	Model.prototype.feedbackClick = function(event){
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl('./yjfk.w'));
	};

	// 退出登录
	Model.prototype.logoutBtnClick = function(event){
		var token = localStorage.getItem("token");
		justep.Baas.sendRequest({
			"url" : "/poetry/user",
			"action" : "logout",
			"params" : {
				"token" : token
			},
			"success" : function(resultData) {
				if (resultData.state == 1) {
					localStorage.removeItem("token");
					common.getHrefCount();
					justep.Shell.showPage(require.toUrl("./main.w?"));
					//+new Date().getTime()
				}
			}
		});
	};

	Model.prototype.backBtnClick = function(event){
		common.getBackCount();
	};

	return Model;
});