define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var touch = require("./js/touch");
	var common = require("./common");

	var Model = function(){
		this.callParent();
		this.row;
	};
	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		$(".loadingDiv").addClass("hide");
		$(".lslist").removeClass("hide");
		this.swipeDelete();
	};
		
	Model.prototype.swipeDelete = function(){
		var newsContentID = this.getIDByXID('newsContents');
		var swipeAreaSize = 100;
		var dx;
		touch.on('#' + newsContentID, 'touchstart', function(ev){
//			ev.preventDefault();	
			var $li = $('#' + newsContentID + " li");
			dx = parseInt($li.has(ev.target).attr('swipeX') || "0");
			$li.each(function(){
				$(this).bind('touchstart',function(e){
					$(this).has(e.target).siblings('li').css({'transform':'translate3d(0, 0, 0)','-webkit-transform':'translate3d(0, 0, 0)','transition': 'transform 0.2s linear 0s','-webkit-transition': 'transform 0.2s linear 0s'});
				});
				
			});

		});
	
		touch.on('#'+ newsContentID, 'drag', function(ev){
			var $swipNode = $('#' + newsContentID + " li").has(ev.target);
			if(ev.direction === "left" || ev.direction === "right"){
				dx = dx || 0;
				var offx = dx + ev.x;
				if(offx < swipeAreaSize*-1){
				offx = swipeAreaSize*-1;
					
				}
				if(offx > 0){
					
					offx = 0;
				}
				if(ev.direction === "right" && $swipNode.hasClass('x-swipe-out')){
					$swipNode.css({'transform':'translate3d('+offx+'px,0,0)','-webkit-transform':'translate3d('+offx+'px,0,0)'});
				}else if(ev.direction === "left" && (!$swipNode.hasClass('x-swipe-out'))){
					$swipNode.css({'transform':'translate3d('+offx+'px,0,0)','-webkit-transform':'translate3d('+offx+'px,0,0)'});
				}
			}
		});
		touch.on('#'+ newsContentID, 'dragend', function(ev){
			var $swipNode = $('#' + newsContentID + " li").has(ev.target);
			if(ev.direction === "left"){
		$swipNode.css({'transform':'translate3d(-'+swipeAreaSize+'px,0,0)','-webkit-transform':'translate3d(-'+swipeAreaSize+'px,0,0)'});
				$swipNode.addClass('x-swipe-out');
				dx = swipeAreaSize*-1;
			}else if(ev.direction === "right"){
				$swipNode.removeClass('x-swipe-out');
				$swipNode.css({'transform':'translate3d(0,0,0)','-webkit-transform':'translate3d(0,0,0)'});
				dx = 0;
			}
			$swipNode.attr('swipeX',dx);
		});
	};
	
	// 跳转朗诵详情页面
	Model.prototype.div6Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./sdDetail.w?reciteId="+row.getID()+"&userId="+this.getContext().getRequestParameter("userId")));
	};
	
	// 获取又拍云全路径
    Model.prototype.getImg = function(str) {
    	return common.imgUrl(str, "ph400");
    };

	// 朗诵和朗诵上传时间操作
	Model.prototype.setUploadPosition = function(time) {
		return common.fbTimeToFormat(time);
	};
	
	// 获取当前用户朗诵
	Model.prototype.reciteDataBeforeRefresh = function(event){
		var data = event.source;
		data.filters.setVar("userId", this.getContext().getRequestParameter("userId"));
	};
	
	// 删除朗诵
	Model.prototype.delBtnClick = function(event){
		this.row = event.bindingContext.$object;
		this.comp("alertDialog").show();
	};

	Model.prototype.alertDialogOK = function(event){
		var poetry = this.comp("poetryData");
		poetry.clear();
		poetry.setFilter("filter", "poetryId=" + this.row.val("poetryId"));
		poetry.refreshData();
		poetry.setValue("reciteCount", (poetry.getValue("reciteCount")-1));
		poetry.saveData();
		
		var self = this;
		var recite = this.comp("reciteData");
		recite.setValue("state", 2, this.row);
		recite.saveData();
		recite.refreshData();
		var url=recite.getValue("url", this.row);
		justep.Baas.sendRequest({
			"url" : "/poetry/recite",
			"action" : "deleteFile",
			"async" : false,
			"params" : {
				str : url
			},
		});
	};

	Model.prototype.backBtnClick = function(event){
		common.getBackCount();
	};

	return Model;
});