define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var common = require("./common");
	var touch = require("./js/touch");

	var Model = function() {
		this.callParent();
		this.row;
		this.type;
	};
	
	Model.prototype.modelLoad = function(event) {
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
			$(".nav").css({"top":"78px"});
			$(".ios-tab-content .tab-pane").css({"top":"50px"});
		}
		this.swipeDelete();
		$(".loadingDiv").addClass("hide");
		$(".firstcontent").removeClass("hide");
	};
	
	Model.prototype.swipeDelete = function() {
		var newsContentID = this.getIDByXID('firstcontent');
		var swipeAreaSize = 100;
		var dx;
		touch.on('#' + newsContentID, 'touchstart', function(ev) {
			// ev.preventDefault();
			var $li = $('#' + newsContentID + " li");
			dx = parseInt($li.has(ev.target).attr('swipeX') || "0");
			$li.each(function() {
				$(this).bind('touchstart', function(e) {
					$(this).has(e.target).siblings('li').css({
						'transform' : 'translate3d(0, 0, 0)',
						'transition' : 'transform 0.2s linear 0s'
					});
				});

			});

		});

		touch.on('#' + newsContentID, 'drag', function(ev) {
			var $swipNode = $('#' + newsContentID + " li").has(ev.target);
			if (ev.direction === "left" || ev.direction === "right") {
				dx = dx || 0;
				var offx = dx + ev.x;
				if (offx < swipeAreaSize * -1) {
					offx = swipeAreaSize * -1;

				}
				if (offx > 0) {

					offx = 0;
				}
				if (ev.direction === "right" && $swipNode.hasClass('x-swipe-out')) {
					$swipNode.css({
						'transform' : 'translate3d(' + offx + 'px,0,0)'
					});
				} else if (ev.direction === "left" && (!$swipNode.hasClass('x-swipe-out'))) {
					$swipNode.css({
						'transform' : 'translate3d(' + offx + 'px,0,0)'
					});
				}
			}
		});
		touch.on('#' + newsContentID, 'dragend', function(ev) {
			var $swipNode = $('#' + newsContentID + " li").has(ev.target);
			if (ev.direction === "left") {
				if ($swipNode.children('.x-swipe-area').children().length > 1) {
					var offx = swipeAreaSize * 2;
					$swipNode.css({
						'transform' : 'translate3d(-' + offx + 'px,0,0)'
					});
				} else {
					$swipNode.css({
						'transform' : 'translate3d(-' + swipeAreaSize + 'px,0,0)'
					});
				}

				$swipNode.addClass('x-swipe-out');
				dx = swipeAreaSize * -1;
			} else if (ev.direction === "right") {
				$swipNode.removeClass('x-swipe-out');
				$swipNode.css({
					'transform' : 'translate3d(0,0,0)'
				});
				dx = 0;
			}
			$swipNode.attr('swipeX', dx);
		});
	};

	// 设置显示的时间格式
	Model.prototype.setTimeFormat = function(time) {
		return common.durationToFormat(time);
	};

	// 朗诵和朗诵上传时间操作
	Model.prototype.setUploadPosition = function(time) {
		return common.fbTimeToFormat(time);
	};

	// 转换格式
	Model.prototype.toPoetryFormat = function(str) {
		return common.textToBr(str);
	};

	// 获取头像
	Model.prototype.getHeadImg = function(str) {
		return common.headUrl(str);
	};

	// 获取又拍云全路径
	Model.prototype.getImg = function(str) {
		return common.imgUrl(str, "ph400");
	};

	Model.prototype.reciteDataBeforeRefresh = function(event) {
		event.source.filters.setVar("userId", this.getContext().getRequestParameter("userId"));
	};

	Model.prototype.poetryDataBeforeRefresh = function(event) {
		event.source.filters.setVar("userId", this.getContext().getRequestParameter("userId"));
	};

	// 点击进入朗诵详情
	Model.prototype.row5Click = function(event) {
		var row = event.bindingContext.$object; // 获取当前行对象
		if(row.val("state")==2||row.val("state")==4||row.val("status")==2){
		   $(".delete1").removeClass("hide");
		}else{
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./sdDetail.w?reciteId=" + row.val("objectId") + "&userId=" + this.getContext().getRequestParameter("userId")));
		}
	};

	// 跳转诗歌详情
	Model.prototype.row14Click = function(event) {
		var row = event.bindingContext.$object;
		if(row.val("state")==2||row.val("state")==4||row.val("status")==2){
		   $(".delete2").removeClass("hide");
		}else{
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./ycsgDetail.w?poetryId=" + row.val("objectId") + "&userId=" + this.getContext().getRequestParameter("userId")));
		}
	};

	// 跳转个人展示页
	Model.prototype.span3Click = function(event) { // 朗诵
		var row = event.bindingContext.$object;
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("reciteUserId")));
	};
	Model.prototype.image1Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("reciteUserId")));
	};
	Model.prototype.span47Click = function(event) { // 诗歌
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("userId")));
	};
	Model.prototype.image2Click = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + row.val("userId")));
	};

	// 删除朗诵收藏
	Model.prototype.rDelBtnClick = function(event) {
		this.row = event.bindingContext.$object;
		this.comp("alertDialog").show();
		this.type = 2;
	};

	// 删除诗歌收藏
	Model.prototype.button2Click = function(event) {
		this.row = event.bindingContext.$object;
		this.comp("alertDialog").show();
		this.type = 1;
	};

	Model.prototype.alertDialogOK = function(event) {
		this.delsc();
	};

	Model.prototype.delsc = function() {
		var self = this;
		var collection = this.comp("collectionData");
		collection.clear();
		collection.setFilter("filter", "collectId=" + this.row.getID());
		collection.refreshData({
			"onSuccess" : function(event) {
				if (collection.count() > 0) {
					collection.deleteAllData();
					collection.saveData();
				}
				if (self.type == 1) {
					self.comp("poetryData").refreshData();
				} else {
					self.comp("reciteData").refreshData();
				}
			}
		});

	};

	Model.prototype.button3Click = function(event){
        $(".delete1").addClass("hide");
	};

	Model.prototype.button4Click = function(event){
		$(".delete2").addClass("hide");
	};

	Model.prototype.backBtnClick = function(event){
		common.getBackCount();
	};

	return Model;
});