define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
//	require("cordova!cordova-plugin-device");
	require("cordova!com.justep.cordova.plugin.iFlytek");
	require("cordova!cordova-plugin-insomnia");
	require("cordova!cordova-plugin-media");
	require("cordova!cordova-plugin-file");
	require("css!./swiper/dist/css/swiper.min").load();
	require("./swiper/dist/js/swiper.min");
	require('./js/jquery.marquee.min');
	var voice = require('./voice');
	var common = require("./common");

	var Model = function(){
		this.callParent();		
		this.userId;
		this.nickName;
		this.title = "";
		this.author = "佚名";
		this.backgroundUrl = "";
		this.luyinTitle = justep.Bind.observable("");
		this.luyinAuthor = justep.Bind.observable("");
		this.luyinContent = justep.Bind.observable("");
		this.titleText = justep.Bind.observable("");
		this.authorText = justep.Bind.observable("");
		
		this.poetryId = 0;
		this.isVisible = justep.Bind.observable(false);
		this.timeLen;
		this.mediaTimer;
		this.recTime;
		this.recordState = 0;
		this.recordUrl;
		this.mediaRec;
		this.marquee;
		this.plaTime;
		this.playTimer;	
		this.address; 
		this.longitude;
		this.latitude;
		this.state = 1;
		this.nick = justep.Bind.observable("");
		this.type;
		this.netTimer;
		this.isVersion = false;
	};
	
	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		var typeData = this.comp("typeData");
		typeData.clear();
		typeData.newData({
			"defaultValues" : [ 
			{
				"name" : "现代诗歌",
				"value" : "2"
			}, 
			{
				"name" : "古代诗歌",
				"value" : "1"
			},
			{
				"name" : "外文诗歌",
				"value" : "3"
			} ]
		});
		$(".ssss").removeClass("hide");
		var self = this;
		$(document).on("click",".choice-img",function(){
			var bgurl = $(this).attr("src");
			self.backgroundUrl = bgurl.split("!")[0] + "!ph400";
			$(".backImg").css("background-image", "url("+self.backgroundUrl+")");
			$('.color').removeClass('color').addClass('colorNew');
			
		});
		document.addEventListener("deviceready", this.onDeviceReady.bind(this), false);
	};
	
	Model.prototype.onDeviceReady = function() {
		plugins.insomnia.keepAwake(function(){
//	        justep.Util.hint("设置常亮成功");
	    }, function(){
//	        justep.Util.hint("设置失败");
	    });
//	    if (device.platform == 'Android' && device.version < '6.0.0') {
//			this.isVersion = true;
//		} else {
//			this.isVersion = false;
//		}
	};

	// 获取参数信息
	Model.prototype.modelParamsReceive = function(event){
		this.userId = event.params.userId;
		this.nickName = event.params.nickName;
	};

	Model.prototype.textarea1Focus = function(event){
		if (this.isVersion) {
			$('.changeIcon').removeClass('hide');
			$('.changeBtn').show();
			$(".lyBtn").addClass("hide");
		}
	};

	Model.prototype.changeBtnClick = function(event){
		$('.changeIcon').addClass('hide');
		$(".lyBtn").removeClass('hide');
		this.micToWordStart(); // 开始录音转换
	};
	
	// 获取背景图
    Model.prototype.getImg = function(str) {
    	return common.imgUrl(str, "pwh90");
    };
	
	// 开始语音转换
	Model.prototype.micToWordStart = function() {
		var self = this;
		navigator.speech.startListening({
			"asr_ptt" : 1,
			"vad_bos" : 10000,
			"vad_eos" : 10000
		}, function(res) {
			self.comp("textarea1").val(self.toPoetryFormat($.trim(self.comp("textarea1").val()).replace(/(\r\n)|(\n)/g, '') + res));
			$(".lyBtn").addClass("hide");
			$(".lyBtn").addClass("hide");
		});
	};
	
	// 结束语音转换
	Model.prototype.micToWordEnd = function() {
		var self = this;
		navigator.speech.stopListening(function(res) {
			self.comp("textarea1").val(self.toPoetryFormat($.trim(self.comp("textarea1").val()).replace(/(\r\n)|(\n)/g, '') + res));
			$(".lyBtn").addClass("hide");
		}, function(res) {
//			alert("stopListen NO :" + JSON.stringify(res));
		});
	};
	
	// 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	str = str.replace(/\。/g, '。\r\n');
    	str = str.replace(/\./g, '.\r\n');
    	str = str.replace(/\,/g, ',\r\n');
    	str = str.replace(/\，/g, '，\r\n');
    	return str;
    };
    
    // 转换格式
    Model.prototype.toPoetryFormatBr = function(str) {
    	return common.textToBr(str);
    };

    // 点击按钮结束录音
	Model.prototype.button4Click = function(event){
		this.micToWordEnd();
	};
	
	// 下一步
	Model.prototype.button2Click = function(event){
		var alertDialog = this.comp("alertDialog");
		var title = this.comp("title2").val();
		if (title === "" || title === null || title === undefined) {
			this.comp("alertDialog").show({message:"请输入标题！"});
			return false;
		}
		if (title.replace(/[^\x00-\xff]/g,"**").length > 28) {
			alertDialog.show({message:'标题最多输入14个字'});
			return false;
		}
		this.title = title;
		var author = this.comp("author").val();
		if (author != "" || author != null || author != undefined) {	
			this.author = author;
		}
		if (author.replace(/[^\x00-\xff]/g,"**").length > 20) {
			alertDialog.show({message:'作者最多输入10个字'});
			return false;
		}
		var content = this.comp("textarea1").val();
		if (content === "" || content === null || content === undefined) {
			this.comp("alertDialog").show({message:"请输入内容！"});
			return false;
		}
		if (content.replace(/[^\x00-\xff]/g,"**").length > 20000) {
			alertDialog.show({message:'内容最多输入10000个字'});
			return false;
		}
		
		event.source.addClass("hide");
		
		// 切换到录音页面
		var self = this;
		this.comp("contents1").to("luyin", function(){
			self.luyinTitle.set(self.title);
			self.luyinAuthor.set(self.author);
			self.luyinContent.set(self.toPoetryFormatBr(content.replace(/(\r\n)|(\n)/g, "")));
			self.nick.set(self.nickName);
		});
	};
	
	// 开始录音、播放、暂停
	Model.prototype.startRecordBtnClick = function(event){
		var me = this;
		if (me.recordState == 0) { // 开始录音
			me.recordState = 1;
			me.comp("recordTime").set({value : "00:00/06:00"});
			$(".recordDescription").text("录音中");
			
			// 定位
			var gpsDtd = common.getGeo();
			gpsDtd.done(function(position) {
				me.address = position.address;
				me.longitude = position.longitude;
				me.latitude = position.latitude;
			});

			// 开始录音
			voice.startRecord({
				cancel:function(){
					//alert("用户拒绝授权录音");
				}
			});
			
			me.recTime = 0;
			me.mediaTimer = setInterval(function() {
				if (me.recTime > 359) {
					me.recordState = 2;
					me.state = 1;
					clearInterval(me.mediaTimer);// 清空计时器
					//me.comp("recordTime").set({value : common.durationToFormat(me.recTime)});
					$(".ly").removeClass("linear linear-mic").addClass("dataControl dataControl-arrowrightl");
					$(".recordDescription").text("试听");
					me.isVisible.set(true);
					// 停止录音
					voice.stopRecord({
						success : function(res) {
							me.url = res.localId;
						},
						fail : function(res) {}
					});
					return;
				}
				me.recTime = me.recTime + 1;
	            me.setAudioPosition(me.recTime);
	            me.comp("recordTime").set({value : me.timeLen+"/06:00"});
			}, 1000);
			
		} else if (me.recordState == 1) { // 结束录音
			me.recordState = 2;
			me.state = 1;
			clearInterval(me.mediaTimer);// 清空计时器
			//me.comp("recordTime").set({value : "00:00:00"});
			$(".ly").removeClass("linear linear-mic").addClass("dataControl dataControl-arrowrightl");
			$(".recordDescription").text("试听");
			me.isVisible.set(true);
			
			// 停止录音
			voice.stopRecord({
				success : function(res) {
					me.recordUrl = res.localId;
				},
				fail : function(res) {
					//alert("无法结束录音！");
				}
			});
			
		} else if (me.recordState == 2) { // 播放
			
			me.recordState = 3;
			$(".ly").removeClass("dataControl-arrowrightl").addClass("dataControl-pausel");
			$(".recordDescription").text("播放中");
			
			// 播放音频
			me.mediaRec = new Media(me.recordUrl, function(option) {
				if (me.state == 1) {
					me.recordState = 2;
					clearInterval(me.netTimer);// 清空计时器
					clearInterval(me.playTimer);// 清空计时器
					me.comp("recordTime").set({value : me.timeLen});
					$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
					$(".recordDescription").text("试听");
					me.marquee.marquee('destroy');
					me.mediaRec.release();
					me.mediaRec = null;
				}
			}, function(err) {});
			me.mediaRec.play();
			
			me.plaTime = 0;
			me.playTimer = setInterval(function() {
				me.plaTime = me.plaTime + 1;
	            me.setAudioPosition(me.plaTime);
	            me.comp("recordTime").set({value : me.timeLen});
			}, 1000);
			
			me.marqueePoetry(); // 滚动文字
			
			// 定时监听网络制式
			var net = localStorage.getItem("wifiAlert");
			if (net == 'on') {
				me.netTimer = setInterval(function() {
					if (me.getNetWork() == '2g' || me.getNetWork() == '3g' || me.getNetWork() == '4g' || me.getNetWork() == 'cellular') {
						me.comp("netTimerDialog").show();
						me.recordState = 4;
						clearInterval(me.netTimer);// 清空计时器
						clearInterval(me.playTimer);// 清空计时器
						$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
						$(".recordDescription").text("暂停");
						me.mediaRec.pause();
						me.marquee.marquee('pause');
					}
				}, 1000);
			}
		
		} else if (me.recordState == 3) { // 暂停
			
			me.recordState = 4;
			clearInterval(me.playTimer);// 清空计时器
			$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
			$(".recordDescription").text("暂停");
			
			me.mediaRec.pause();
			me.marquee.marquee('pause');
		
		} else if (me.recordState == 4) { // 继续播放
			
			me.recordState = 3;
			$(".ly").removeClass("dataControl-arrowrightl").addClass("dataControl-pausel");
			$(".recordDescription").text("播放中");
			me.playTimer = setInterval(function() {
				me.plaTime = me.plaTime + 1;
	            me.setAudioPosition(me.plaTime);
	            me.comp("recordTime").set({value : me.timeLen});
			}, 1000);
			me.mediaRec.play();
			me.marquee.marquee('resume');
		}
	};
	Model.prototype.netTimerDialogOK = function(event){
		this.recordState = 3;
		$(".ly").removeClass("dataControl-arrowrightl").addClass("dataControl-pausel");
		$(".recordDescription").text("播放中");
		this.playTimer = setInterval(function() {
			this.plaTime = this.plaTime + 1;
            this.setAudioPosition(this.plaTime);
            this.comp("recordTime").set({value : this.timeLen});
		}, 1000);
		this.mediaRec.play();
		this.marquee.marquee('resume');
	};
	Model.prototype.netTimerDialogCancel = function(event){
		this.recordState = 2;
		clearInterval(this.playTimer);// 清空计时器
		this.comp("recordTime").set({value : "00:00:00"});
		$(".ly").removeClass("dataControl-pausel").addClass("dataControl-arrowrightl");
		$(".recordDescription").text("试听");
		this.marquee.marquee('destroy');
		this.mediaRec.stop();
	};
	
    // 重录
	Model.prototype.resetBtnClick = function(event){
		this.resetRecode();
		this.recordUrl = "";
	};
	
	//设置显示的时间
    Model.prototype.setAudioPosition = function(position) {
    	var hour = parseInt(position / 3600);// 小时数
		var min = parseInt(position / 60);// 分钟数
		if (min >= 60) {
			min = min % 60;
		}
		var lastsecs = position % 60;
		if(hour < 10) hour = "0" + hour;
		if(min < 10) min = "0" + min;
		if(lastsecs < 10) lastsecs = "0" + lastsecs;
		
		this.timeLen = min + ':' + lastsecs;
    };
    
    // 滚动文字
    Model.prototype.marqueePoetry = function() {
    	var self = this;
		// 显示诗词
		this.marquee = $(".marquee").bind('finished', function(){
	        //Change text to something else after first loop finishes
	        $(this).marquee('destroy');
		}).marquee({
		    //speed in milliseconds of the marquee
		    duration: self.recTime >=2 ? parseInt(self.recTime*500) : 300,
		    //gap in pixels between the tickers
		    gap: 50,
		    //time in milliseconds before the marquee will start animating
		    delayBeforeStart: 0,
		    //'left' or 'right'
		    direction: 'up',
		    //true or false - should the marquee be duplicated to show an effect of continues flow
		    duplicated: false
		});
    };
    
    // 初始参数
    Model.prototype.resetRecode = function() {
    	this.recordState = 0;
    	clearInterval(this.netTimer);// 清空计时器
		clearInterval(this.playTimer);// 清空计时器
		clearInterval(this.mediaTimer);// 清空计时器
		this.comp("recordTime").set({value : ""});
		$(".recordDescription").text("按一下开始录音");
		$(".ly").removeClass("dataControl dataControl-arrowrightl dataControl-pausel").addClass("linear linear-mic").css('margin-left','0px');
		this.isVisible.set(false);
		this.timeLen = "";
//		this.recTime = 0;
		this.plaTime = 0;
//		this.address = "";
//		this.longitude = 0;
//		this.latitude = 0;
		this.state = 0;
		if (this.mediaRec != null || this.mediaRec != undefined) {
			this.mediaRec.stop();
			this.mediaRec.release();
			this.marquee.marquee('destroy');
		}
		voice.stopRecord({
			success : function(res) {},
			fail : function(res) {}
		});
    };

    // 下一步
	Model.prototype.nextBtnClick = function(event){
		if (this.recTime <= 10) {
			this.comp("alertDialog").show({message:"录制时间太短，多诵读两句再保存吧！"});
			return false;
		}
		this.state = 0;
		this.resetRecode();
		var self = this;
		this.comp("contents1").to("fabu", function(){
			var swiper = new Swiper('.swiper-container', {
				slidesPerView : 3,
				centeredSlides : true,
				paginationClickable : true,
	//			spaceBetween : 15,
				loop:true,
			});
			$('.swiper-wrapper li').css('width','');
			
			
			self.titleText.set(self.title);
			self.authorText.set(self.author);
		});
	};

	// 发布
	Model.prototype.fbButtonClick = function(event){
		if (this.isToken()) {
			if (this.backgroundUrl == null || this.backgroundUrl == undefined || this.backgroundUrl == "") {
				this.comp("alertDialog").set({message:"请选择背景图片！"});
				this.comp("alertDialog").show();
				return;
			}
			if (this.comp("select1").val() == "" || this.comp("select1").val() == null || this.comp("select1").val() == undefined) {
				this.comp("alertDialog").set({message:"请选择分类！"});
				this.comp("alertDialog").show();
				return;
			}
			this.saveRecord(1);
		}
	};
	
	Model.prototype.saveRecord = function(type) {
		this.type = type;
		if (this.getNetWork() != 'wifi') {
			this.comp("netWorkDialog").show();
		} else {
			this.uploadRecord(type);
		}
	};
	Model.prototype.netWorkDialogOK = function(event){
		this.uploadRecord(this.type);
	};
	Model.prototype.uploadRecord = function(type) {
		this.comp("popOver1").show();
		var self = this;
//		var recite = JSON.parse(localStorage.getItem("recite"));
		var poetryData = this.comp("poetryData");
		var reciteData = this.comp("reciteData");
		poetryData.clear();
		reciteData.clear();
		
		var date = new Date();
		poetryData.newData({
			defaultValues : [ {
				title : self.title,// 诗歌标题
				content : self.comp("textarea1").val().replace(/(\r\n)|(\n)/g, ""),// 诗歌内容
				dynasty : '现代',// 诗歌朝代
				author : self.author,// 诗作者
				userId : self.userId,// 发布者ID
				nickName : self.nickName,// 发布者昵称
				type : self.comp("select1").val(),// 诗歌类别
				createTime : date,// 上传时间
				backgroundImg : (self.backgroundUrl.toString().split(".com")[1]).split("!")[0],// 背景图
				commentCount : 0,// 评论数量
				readCount : 0,// 阅读数量
				reciteCount : type == 1 ? 1 : 0,// 朗诵次数
				retransmissionCount : 0,// 转发数量
				address : self.address,// 定位地址
				longitude : self.longitude,// 经度
				latitude : self.latitude,// 纬度
				reciteLastTime : date,// 最后朗诵的时间
				state : 1,
				status:1    //  用户是否删除
			} ]
		});
		poetryData.saveData({
			"onSuccess": function(event) {
				poetryData.clear();
				poetryData.setFilter("filter", "userId="+self.userId);
				poetryData.refreshData();
				// 上传录音
				voice.uploadVoice({
					localId : self.recordUrl,
					userId : self.userId,
					fileType : "mic",
					success : function(res) {
						var data = res.serverId;
						var gbUrl = self.backgroundUrl.toString().split(".com")[1];
						gbUrl = gbUrl.split("!")[0];
						reciteData.newData({
							defaultValues : [ {
								poetryId : poetryData.getCurrentRowID(),// 诗歌ID
								url : data.fileUrl,// 路径
								reciteUserId : self.userId,// 朗诵者ID
								poetryUserId : self.userId,// 诗歌发布者ID
								state : type,// 状态
								listenCount : 0,// 收听次数
								address : self.address,// 定位地址
								commentCount : 0,// 评论数量
								retransmissionCount : 0,// 转发数量
								longitude : self.longitude,// 经度
								latitude : self.latitude,//纬度
								reciteTime : self.recTime,// 朗诵时长
								uploadTime : date,// 上传时间
								backgroundImg : gbUrl,// 背景图
								reciteNickName : self.nickName,// 朗诵者昵称
								poetryTitle : self.title,// 诗歌标题
								poetryNickName : self.nickName,// 诗歌发布者昵称
								author : self.author,// 诗作者
								type : (self.comp("checkbox1").checked ? 2 : 1),// 状态
								status :1//状态
							} ]
						});
						reciteData.saveData({
							"onSuccess": function(event) {
								self.comp("popOver1").hide();
								var sss = type == 3 ? "已存入草稿箱" : "恭喜您，发布成功";
								self.comp("fbSuccessDialog").show({message:sss});
							}
						});
					}
				});
			},
			"onError": function(event) {
				self.comp("popOver1").hide();
				self.comp("alertDialog").show({message:"发布失败！"});
			}
		});
		
	};
	
	// 存草稿箱
	Model.prototype.cgButtonClick = function(event) {
		if (this.isToken()) {
			if (this.backgroundUrl == null || this.backgroundUrl == undefined || this.backgroundUrl == "") {
				this.comp("alertDialog").set({message:"请选择背景图片！"});
				this.comp("alertDialog").show();
				return;
			}
			if (this.comp("select1").val() == "" || this.comp("select1").val() == null || this.comp("select1").val() == undefined) {
				this.comp("alertDialog").set({message:"请选择分类！"});
				this.comp("alertDialog").show();
				return;
			}
			this.comp('cgxDialog').show();
		}
	};
	Model.prototype.cgxDialogOK = function(event){
		this.saveRecord(3);
	};
	
	// 发布成功
	Model.prototype.fbSuccessDialogOK = function(event){
		justep.Shell.closePage();
	};
	
	// 判断token
	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};
	
	// 获取网络
	Model.prototype.getNetWork = function() {
		return common.getNetWork();
	};
	
	// 离开页面
	Model.prototype.modelInactive = function(event){
		this.resetRecode();
		plugins.insomnia.allowSleepAgain(function(){
//	        justep.Util.hint("设置自动息屏成功");
	    }, function(){
//	        justep.Util.hint("设置失败");
	    });
	};
	
	
	// 返回上一页
	Model.prototype.button1Click = function(event){
		if (this.recordUrl != null && this.recordUrl != undefined) {
			this.comp("backDialog").show();
		} else {
			common.getBackCount();
		}
	};	
	Model.prototype.backDialogOK = function(event){
		common.getBackCount();
	};
	
	Model.prototype.checkbox1Change = function(event){
		if (event.source.checked) {
			event.source.set("checked", false);
		} else {
			event.source.set("checked", true);
		}
	};
	
	return Model;
});