define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
//	require("cordova!cordova-plugin-device");
	require("cordova!com.justep.cordova.plugin.iFlytek");
	require("cordova!cordova-plugin-insomnia");
	require("css!./swiper/dist/css/swiper.min").load();
	require("./swiper/dist/js/swiper.min");
	var common = require("./common");

	var Model = function(){
		this.callParent();
		this.userId;
		this.nickName;
		this.title = "";
		this.author = "佚名";
		this.backgroundUrl = "";
		this.address = "";
		this.longitude = 0;
		this.latitude = 0;
		this.titleText = justep.Bind.observable("");
		this.authorText = justep.Bind.observable("");
		this.isVersion = false;
	};
	
	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		var typeData = this.comp("typeData");
		typeData.clear();
		typeData.newData({
			"defaultValues" : [ 
			{
				"name" : "现代诗歌",
				"value" : "2"
			}, 
			{
				"name" : "古代诗歌",
				"value" : "1"
			},
			{
				"name" : "外文诗歌",
				"value" : "3"
			} ]
		});
		document.addEventListener("deviceready", this.onDeviceReady.bind(this), false);
	};
	
	Model.prototype.onDeviceReady = function() {
		plugins.insomnia.keepAwake(function(){
//	        justep.Util.hint("设置常亮成功");
	    }, function(){
//	        justep.Util.hint("设置失败");
	    });		
//	    if (device.platform == 'Android' && device.version < '6.0.0') {
//			this.isVersion = true;
//		} else {
//			this.isVersion = false;
//		}
	};

	// 获取参数信息
	Model.prototype.modelParamsReceive = function(event){
		this.userId = event.params.userId;
		this.nickName = event.params.nickName;
	};
	
	// 获取背景图
    Model.prototype.getImg = function(str) {
    	return common.imgUrl(str, "pwh90");
    };

	Model.prototype.textarea1Focus = function(event){
		if (this.isVersion) {
			$('.changeIcon').removeClass('hide');
			$('.changeBtn').show();
			$(".lyBtn").addClass("hide");
		}
	};

	Model.prototype.changeBtnClick = function(event){
		$('.changeIcon').addClass('hide');
		$(".lyBtn").removeClass('hide');
		this.micToWordStart(); // 开始录音转换
	};
	
	// 开始语音转换
	Model.prototype.micToWordStart = function() {
		var self = this;
		navigator.speech.startListening({
			"asr_ptt" : 1,
			"vad_bos" : 10000,
			"vad_eos" : 10000
		}, function(res) {
			self.comp("textarea1").val(self.toPoetryFormat($.trim(self.comp("textarea1").val()).replace(/(\r\n)|(\n)/g, '') + res));
			$(".lyBtn").addClass("hide");
		}, function(res){
			//alert("startListen NO :" + JSON.stringify(res));
		});
	};
	
	// 结束语音转换
	Model.prototype.micToWordEnd = function() {
		var self = this;
		navigator.speech.stopListening(function(res) {
			self.comp("textarea1").val(self.toPoetryFormat($.trim(self.comp("textarea1").val()).replace(/(\r\n)|(\n)/g, '') + res));
			$(".lyBtn").addClass("hide");
		}, function(res) {
			//alert("stopListen NO :" + JSON.stringify(res));
		});
	};
	
	// 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	str = str.replace(/\。/g, '。\r\n');
    	str = str.replace(/\./g, '.\r\n');
    	str = str.replace(/\,/g, ',\r\n');
    	str = str.replace(/\，/g, '，\r\n');
    	return str;
    };

    // 点击按钮结束录音
	Model.prototype.startRecordBtnClick = function(event){
		this.micToWordEnd();
	};
	
	// 下一步
	Model.prototype.button2Click = function(event){
		var title = this.comp("title").val();
		var alertDialog = this.comp("alertDialog");
		if ($.trim(title) == "" || $.trim(title) == null || $.trim(title) == undefined) {
			alertDialog.show({message:'请输入标题'});
			return false;
		}
		if ($.trim(title).replace(/[^\x00-\xff]/g,"**").length > 28) {
			alertDialog.show({message:'标题最多输入14个字'});
			return false;
		}
		this.title = title;
		var author = this.comp("author").val();
		if ($.trim(author) == "" || $.trim(author) == null || $.trim(author) == undefined) {
			alertDialog.show({message:'请输入作者'});
			return false;
		}
		if ($.trim(author).replace(/[^\x00-\xff]/g,"**").length > 20) {
			alertDialog.show({message:'作者最多输入10个字'});
			return false;
		}
		this.author = author;
		var content = this.comp("textarea1").val();
		if ($.trim(content) == "" || $.trim(content) == null || $.trim(content) == undefined) {
			alertDialog.show({message:'请输入内容'});
			return false;
		}
		if ($.trim(content).replace(/[^\x00-\xff]/g,"**").length > 20000) {
			alertDialog.show({message:'内容最多输入10000个字'});
			return false;
		}
		event.source.addClass("hide");
		var self = this;
		this.comp("contents1").to("fb", function(){
			var swiper = new Swiper('.swiper-container', {
				slidesPerView : 3,
				centeredSlides : true,
				paginationClickable : true,
	//			spaceBetween : 15,
				loop:true,
			});
			$('.swiper-wrapper li').css('width','');
			
			self.titleText.set(self.title);
			self.authorText.set(self.author);
			
			// 选择背景图
			$(document).on("click",".choice-img",function(){
				var bgurl = $(this).attr("src");
				self.backgroundUrl = bgurl.split("!")[0] + "!ph400";
				$(".backImg").css("background-image", "url("+self.backgroundUrl+")");
				$('.color').removeClass('color').addClass('colorNew');
			});
		});
	};

	// 发布
	Model.prototype.fbButtonClick = function(event){
		if (this.isToken()) {
			if (this.backgroundUrl == null || this.backgroundUrl == undefined || this.backgroundUrl == "") {
				this.comp("alertDialog").show({message:'请选择背景图片'});
				return;
			}
			
			if (this.comp("select1").val() == "" || this.comp("select1").val() == null || this.comp("select1").val() == undefined) {
				this.comp("alertDialog").show({message:'请选择分类'});
				return;
			}
			this.savePoetry(1);
		}
	};
	
	// 存草稿箱
	Model.prototype.cgButtonClick = function(event) {
		if (this.isToken()) {
			if (this.backgroundUrl == null || this.backgroundUrl == undefined || this.backgroundUrl == "") {
				this.comp("alertDialog").show({message:'请选择背景图片'});
				return;
			}
			
			if (this.comp("select1").val() == "" || this.comp("select1").val() == null || this.comp("select1").val() == undefined) {
				this.comp("alertDialog").show({message:'请选择分类'});
				return;
			}
			this.comp('cgxDialog').show();
		}
	};
	Model.prototype.cgxDialogOK = function(event){
		this.savePoetry(3);
	};
	
	// 保存诗歌
	Model.prototype.savePoetry = function(type) {
		this.comp("popOver1").show();
		var self = this;
		self.fabu(type);
		// 定位
//		var gpsDtd = common.getGeo();
//		gpsDtd.done(function(position) {
//			self.address = position.address;
//			self.longitude = position.longitude;
//			self.latitude = position.latitude;
//			self.fabu(type);
//		}).fail(function(){
//			self.fabu(type);
//		});
	};
	
	Model.prototype.fabu = function(type) {
		var self = this;
		var data = self.comp("poetryData");
		data.clear();
		data.newData({
			defaultValues : [ {
				title : self.title,// 诗歌标题
				content : $.trim(self.comp("textarea1").val()),// 诗歌内容
				dynasty : '现代',// 诗歌朝代
				author : self.author,// 诗作者
				userId : self.userId,// 发布者ID
				nickName : self.nickName,// 发布者昵称
				type : self.comp("select1").val(),// 诗歌类别
				createTime : new Date(),// 上传时间
				backgroundImg : (self.backgroundUrl.toString().split(".com")[1]).split("!")[0],// 背景图
				commentCount : 0,// 评论数量
				readCount : 0,// 阅读数量
				reciteCount : 0,// 朗诵次数
				retransmissionCount : 0,// 转发数量
				address : self.address,// 定位地址
				longitude : self.longitude,// 经度
				latitude : self.latitude,// 纬度
				reciteLastTime : null,// 最后朗诵的时间
				state : type,// 状态
				status :1
			} ]
		});
		data.saveData({
			"onSuccess": function(event) {
				self.comp("popOver1").hide();
				var sss = type == 3 ? "已存入草稿箱" : "恭喜您，发布成功";
				self.comp("fbSuccessDialog").show({message:sss});
			},
			"onError": function(event) {
				self.comp("popOver1").hide();
				var sss = (type == 3 ? "存入草稿箱" : "发布") + "失败";
				self.comp("alertDialog").show({message:sss});
			}
		});
	};
	
	// 发布成功
	Model.prototype.fbSuccessDialogOK = function(event){
		justep.Shell.closePage();
	};

	// 判断token
	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl('./login.w'));
		}
		return result.bool;
	};

	Model.prototype.modelInactive = function(event){
		plugins.insomnia.allowSleepAgain(function(){
//	        justep.Util.hint("设置自动息屏成功");
	    }, function(){
//	        justep.Util.hint("设置失败");
	    });
	};

	// 返回上一页
	Model.prototype.button1Click = function(event){
		var content = this.comp("textarea1").val();
		if (content != "" && content != null && content != undefined) {
			this.comp("backDialog").show();
		} else {
			common.getBackCount();
		}
	};
	Model.prototype.backDialogOK = function(event){
		common.getBackCount();
	};

	return Model;
});