define(function(require){
	require("cordova!com.justep.cordova.plugin.qq");
	require("cordova!com.justep.cordova.plugin.weibo");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	var utils = require("$UI/system/components/justep/common/utils");
	var justep = require("$UI/system/lib/justep");
	var $ = require("jquery");
	var common = require("./common");

	var Model = function(){
		this.callParent();
		this.userId = 0;
		this.nickName;
	};
	
	// 转换格式
    Model.prototype.toPoetryFormat = function(str) {
    	if (str != undefined) {
    		return common.textToBr(str);
    	} else {
    		return "";
    	}
    };
    
    // 获取头像
    Model.prototype.getHeadImg = function(str) {
    	return common.headUrl(str);
    };
    
	// 获取又拍云全路径
    Model.prototype.getUrl = function(str) {
    	return common.imgUrl(str, "ph400");
    };
    
    // 日期转换
	Model.prototype.toDateFormat = function(str) {
    	if (str != undefined && str != null && str != "") {
    		var array = str.toString().split(" ");
    		var arr1 = array[0].toString().split("-");
    		var str1 = arr1[1] + "." + arr1[2];
    		var arr2 = array[1].toString().split(":");
    		var str2 = arr2[0] + ":" + arr2[1];
    		str = str1 + " " + str2;
    	}
    	return str;
    };
	
	// 保存消息
	Model.prototype.saveMessage = function(userId, title, type) {
		if (userId != 0 && userId != this.userId){ // 判断当前用户是否为诗歌发布者
			var self = this;
			var messageData = this.comp("messageData");
			messageData.clear();
			var typeVal = type == 1 ? '赞' : type == 2 ? '评论' : type == 3 ? '订阅' : type == 4 ? '分享' : type == 5 ? '系统' : '朗诵';
			var messageContent = "";
			if (type == 3) {
				messageContent = typeVal + "了您";
			} else {
				messageContent = typeVal + "了您的诗歌" + title;
			}
			messageData.newData({
				"defaultValues" : [ {
					"userId" : userId,
					"content" : messageContent,
					"state" : 1,
					"createTime" : new Date(),
					"type" : type,
					"pushUserId" : self.userId,
					"pushNickName" : self.nickName,
					"isRead" : 1
				} ]
			});
			messageData.saveData({
				"onSuccess" : function(event) {
					if (type == 1 || type == 2 || type == 3 || type == 6) {
						justep.Baas.sendRequest({
							"method" : "post",
							"url" : "/poetry/pjush",
							"action" : "sendMessage",
							"params" : {
								registrationId : "",
								tag : "",
								alias : userId,
								title : self.nickName + messageContent
							}
						});
					}
				}
			});
		}
	};

	// 判断token
	Model.prototype.isToken = function() {
		// 判断用户是否登录
		var result = common.isToken();
		if (result.bool) {
			this.userId = result.userId;
			this.nickName = result.nickName;
		} else {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl("./login.w"));
		}
		return result.bool;
	};
	
	// 收藏
	Model.prototype.scBtnClick = function(event){
		if (this.isToken()) {
			var data = this.comp("poetryData");
			var collectionData = this.comp("collectionData");
			collectionData.clear();
			if (data.getValue("collectId") === 0 || data.getValue("collectId") === undefined) {
				collectionData.newData({
					"defaultValues" : [ {
						"objectId" : data.getCurrentRowID(),
						"type" : 1,
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				collectionData.saveData({
					"onSuccess": function(event){
						data.setValue("collectId", 1);
					}
				});
			} else {
				
				collectionData.setFilter("filter", "objectId="+data.getCurrentRowID() +" and userId="+this.userId + " and type=1");
				collectionData.refreshData({
					"onSuccess": function(event) {
						if (collectionData.count() > 0) {
							collectionData.deleteData([ collectionData.getCurrentRow() ], {
								"onSuccess": function(event) {
									collectionData.saveData({
										"onSuccess": function(event) {
											data.setValue("collectId", 0);
										}
									});
								}
							});
						}
					}
				});
			}
		} 
	};
	
	// 订阅
	Model.prototype.subBtnClick = function(event){
		var m = this;
		var self = event.source;
		if (this.isToken()) {
			self.set({"disabled": true});
			var data = this.comp("poetryData");
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId=" + this.userId + " and subUserId=" + data.getValue("userId"));
			subData.refreshData();
			if (subData.count() == 0) {
				subData.newData({
					"defaultValues" : [ {
						"subUserId" : data.getValue("userId"),
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				subData.saveData({
					"onSuccess":function(event){
						data.setValue("subscribeId", 1);
						self.set({"disabled": false});
						m.saveMessage(data.getValue("userId"), data.getValue("title"), 3);
					},"onError":function(event) {
						self.set({"disabled": false});
					}
				});
			} else {
				data.setValue("subscribeId", 1);
				self.set({"disabled": false});
			}
		}
	};
	// 取消订阅
	Model.prototype.sub1BtnClick = function(event){
		var m = this;
		if (this.isToken()) {
			var data = this.comp("poetryData");
			var subData = this.comp("subData");
			subData.clear();
			subData.setFilter("filter", "userId="+this.userId +"and subUserId="+data.getValue("reciteUserId"));
			subData.refreshData({
				"onSuccess": function(event) {
					if (subData.count() > 0) {
						subData.deleteData([ subData.getCurrentRow() ], {
							"onSuccess": function(event) {
								subData.saveData({
									"onSuccess": function(event) {
										data.setValue("subscribeId", 0);
									}
								});
							}
						});
					}
				}
			});
		}
	};
	
	// 跳转评论页面
	Model.prototype.commentBtnClick = function(event){
		common.getHrefCount();
		var row = event.bindingContext.$object; // 获取当前行对象
		justep.Shell.showPage(require.toUrl("./plList.w?Id=" + this.comp("poetryData").getCurrentRowID() + "&type=1"));
	};
	
	//我来诵读
	Model.prototype.rediteBtnClick = function(event){
		if (this.isToken()) {
			common.getHrefCount();
			justep.Shell.showPage(require.toUrl("./lslz.w?poetryId="+this.comp("poetryData").getCurrentRowID()), {userId: this.userId, nickName: this.nickName}); // token验证成功跳转录制页面	
		}
	};
		
	// 分享
	Model.prototype.shareClick = function(event){
		this.comp("popOver1").show();
	};
	
	// 微信分享
	Model.prototype.wxBtnClick = function(event){
		var self = this;
		var data = self.comp("poetryData");
		function success(result) {
			self.savePoetry(data);
			self.saveMessage(data.getValue("userId"), data.getValue("title"), 4);
		}
		function error(result) {
			if (result != '用户点击取消并返回') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		navigator.weixin.share({
			message : {
				title : data.getValue("title"),
				description : "作者：" + data.getValue("author"),
				mediaTagName : "Media Tag Name(optional)",
				thumb : common.imgUrl(data.getValue("backgroundImg"), "pt50"),
				media : {
					 type: navigator.weixin.Type.WEBPAGE, // webpage
					 webpageUrl : common.sharePoetryUrl + data.getCurrentRowID()
				// webpage
				}
			},
			scene : navigator.weixin.Scene.SESSION
		}, success, error);
		self.comp("popOver1").hide();
	};
    
    // 朋友圈分享
	Model.prototype.pyqBtnClick = function(event){
		var self = this;
		var data = self.comp("poetryData");
		function success(result) {
			self.savePoetry(data);
			self.saveMessage(data.getValue("userId"), data.getValue("title"), 4);
		}
		function error(result) {
			if (result != '用户点击取消并返回') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		navigator.weixin.share({
			message : {
				title : data.getValue("title"),
				description : "作者：" + data.getValue("author"),
				mediaTagName : "Media Tag Name(optional)",
				thumb : common.imgUrl(data.getValue("backgroundImg"), "pt50"),
				media : {
					 type: navigator.weixin.Type.WEBPAGE, // webpage
					 webpageUrl : common.sharePoetryUrl + data.getCurrentRowID()
				// webpage
				}
			},
			scene : navigator.weixin.Scene.TIMELINE
		}, success, error);
		self.comp("popOver1").hide();
	};
    
    // 微博分享
	Model.prototype.wbBtnClick = function(event){
		var self = this;
		var data = self.comp("poetryData");
		function success(result) {
			self.savePoetry(data);
			self.saveMessage(data.getValue("userId"), data.getValue("title"), 4);
		}
		function error(result) {
			self.comp("alertDialog").show({message:"分享失败！"});
		}
		var args = {};
		//这里是新插件的写法 分享图片+网页
		args.url = common.sharePoetryUrl + data.getCurrentRowID();
		args.defaultText = data.getValue("title")+"-"+data.getValue("author");
		args.media = {
			type : "image",
			title : data.getValue("title"),
			description : "作者：" + data.getValue("author"),
			url : common.imgUrl(data.getValue("backgroundImg"), "pt50")
		};
		navigator.Weibo.shareToWeibo(success, error, args);
		self.comp("popOver1").hide();
	};
    
    // qq分享
	Model.prototype.qqBtnClick = function(event){
		var self = this;
		var data = self.comp("poetryData");
		function success(result) {
			self.savePoetry(data);
			self.saveMessage(data.getValue("userId"), data.getValue("title"), 4);
		}
		function error(result) {
			if (result != 'cancelled by user') {
				self.comp("alertDialog").show({message: '分享失败'});
			}
		}
		var args = {};
		args.url = utils.getShareUrl(common.sharePoetryUrl + data.getCurrentRowID());
		args.title =  data.getValue("title");
		args.description = "作者：" + data.getValue("author");
		args.imageUrl = common.imgUrl(data.getValue("backgroundImg"), "pt50");
		args.appName = "share";	
		navigator.QQ.shareToQQ(success, error, args);
		self.comp("popOver1").hide();
	};
    
    // 当前诗歌分享次数加一
    Model.prototype.savePoetry = function(data) {
		data.setValue("retransmissionCount", data.getValue("retransmissionCount") + 1);
		data.saveData();
    };
	
	Model.prototype.poetryDataBeforeRefresh = function(event){
		var data = event.source;
		data.clear();
		if (this.getContext().getRequestParameter("userId") != undefined && this.getContext().getRequestParameter("userId") != null) {
			this.userId = this.getContext().getRequestParameter("userId");
		}
		data.filters.setVar("userId", this.userId);
		data.filters.setVar("poetryId", this.getContext().getRequestParameter("poetryId"));
	};
	
	Model.prototype.modelLoad = function(event){
		if (device.platform == "Android") {
			$(".x-has-iosstatusbar").css({"top":"0px"});
		} else {
			$(".x-has-iosstatusbar").css({"top":"20px"});
		}
		this.comp("popOver2").hide();
		this.comp("panel1").removeClass("hide");
		var poetryData = this.comp("poetryData");
		poetryData.setValue("readCount", (poetryData.getValue("readCount") + 1));
		poetryData.saveData();
	};
	
	// 是否显示订阅
	Model.prototype.isDy = function(uid, subId) {
		return (subId == undefined || subId == 0) && uid != this.getContext().getRequestParameter("userId");
	};
	Model.prototype.isYdy = function(uid, subId) {
		return subId > 0 && uid != this.getContext().getRequestParameter("userId");
	};
	
	// 跳转诗歌朗诵列表页面
	Model.prototype.col5Click = function(event){
		common.getHrefCount();
		var data = this.comp("poetryData");
		justep.Shell.showPage(require.toUrl('./sglsList.w?poetryId='+data.getCurrentRowID()+'&userId='+this.getContext().getRequestParameter("userId")+'&title='+data.getValue("title")));
	};
	
	// 跳转个人展示
	Model.prototype.image1Click = function(event){
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + this.comp("poetryData").getValue("userId")));
	};
	Model.prototype.span11Click = function(event){
		common.getHrefCount();
		justep.Shell.showPage(require.toUrl("./gry.w?userId=" + this.comp("poetryData").getValue("userId")));
	};
	
	// 点赞
	Model.prototype.zanBtnClick = function(event){
		var m = this;
		if (this.isToken()) {
			var data = this.comp("poetryData");
			var praiseData = this.comp("praiseData");
			praiseData.clear();
			if (data.getValue("praiseId") === 0 || data.getValue("praiseId") === undefined) {
				praiseData.newData({
					"defaultValues" : [ {
						"objectId" : data.getCurrentRowID(),
						"type" : 1,
						"userId" : this.userId,
						"createTime" : new Date()
					} ]
				});
				praiseData.saveData({
					"onSuccess": function(event){
						data.setValue("praiseId", 1);
						m.saveMessage(data.getValue("userId"), data.getValue("title"), 1);
					}
				});
			} else {
				praiseData.setFilter("filter", "objectId="+data.getCurrentRowID() +" and userId="+this.userId + " and type=1");
				praiseData.refreshData({
					"onSuccess": function(event) {
						if (praiseData.count() > 0) {
							praiseData.deleteData([ praiseData.getCurrentRow() ], {
								"onSuccess": function(event) {
									praiseData.saveData({
										"onSuccess": function(event) {
											data.setValue("praiseId", 0);
										}
									});
								}
							});
						}
					}
				});
			}
		} 
	};
	

//	Model.prototype.modelActive = function(event) {
//		this.comp("poetryData").refreshData();
//	};
	
	Model.prototype.backBtnClick = function(event){
		common.getBackCount();
	};
	
	return Model;
});